<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Add to crontab (to have it run every 1 minute):
//
// * * * * * /usr/local/bin/php /home/ppcron/cronjobs/cleanup_email_candidates_cron.php
//

// pwd of a cronjob seems to be the cron user's (ppcron) home directory.
// This messes up includes, so we're going to explicitly use the directory
// of this file.
$current_directory = substr($argv[0], 0, strrpos($argv[0], "/"));

//
// Remove expired email_candidates.
// Any email_candidate older than email_candidate_ttl is deleted.
//
$_SERVER["DOCUMENT_ROOT"] = $current_directory;
include($current_directory."/config.php");

// Don't run if this job is already running.

if ($f = @fopen($config["cleanup_email_candidates_pid_file"], "r"))
{
    $pid = (int)fgets($f);
    fclose($f);
    exit("{$argv[0]} is already running, pid {$pid}\n");
}

if ($f = @fopen($config["cleanup_email_candidates_pid_file"], "w"))
{
    $pid = getmypid();
    fputs($f, $pid."\n");
    fclose($f);
}
else
{
    echo "Can't create {$config["cleanup_email_candidates_pid_file"]}, keep running anyway.\n";
}

include($current_directory."/includes/sql_error_cli.php");

// Clean up expired email_candidates.
// note: email_candidate_date is not cleared as it's still used to throttle
// number of emails the user can cause to be sent out

// Don't need to parameterize the $config value.
$query =
    "UPDATE user ".
    "SET email_candidate = NULL, email_candidate_token = NULL ".
    "WHERE (email_candidate_date < (UNIX_TIMESTAMP() - \"{$config['email_candidate_ttl']}\")) AND (email_candidate IS NOT NULL)";

if (!db_query_execute($config, $query, convert_null_array(array()), true))
{
    @unlink($config["cleanup_email_candidates_pid_file"]);
    sql_error_cli($query, $config['sql']);
}

@unlink($config["cleanup_email_candidates_pid_file"]);

exit(0);
?>
