<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Add to crontab (to have it run every 1 minute):
//
// * * * * * /usr/local/bin/php /home/ppcron/cronjobs/cleanup_sessions_cron.php
//

// pwd of a cronjob seems to be the cron user's (ppcron) home directory.
// This messes up includes, so we're going to explicitly use the directory
// of this file.
$current_directory = substr($argv[0], 0, strrpos($argv[0], "/"));

//
// Remove expired sessions.
// Any session with last_activity older than session_ttl is deleted.
//
$_SERVER["DOCUMENT_ROOT"] = $current_directory;
include($current_directory."/config.php");
include($current_directory."/includes/sql_error_cli.php");
include($current_directory."/includes/cr.php");

// Don't run if this job is already running.

if ($f = @fopen($config["cleanup_sessions_pid_file"], "r"))
{
    $pid = (int)fgets($f);
    fclose($f);
    exit("{$argv[0]} is already running, pid {$pid}\n");
}



if ($f = @fopen($config["cleanup_sessions_pid_file"], "w"))
{
    $pid = getmypid();
    fputs($f, $pid."\n");
    fclose($f);
}
else
{
    echo "Can't create {$config["cleanup_sessions_pid_file"]}, keep running anyway.\n";
}


// Cleanup all expired sessions
//
// For anonymous users (grp = 4), delete the user and cookie.  For regular users,
// clear the session and delete the expired cookies (same as logout.php).
// also deletes orphaned cookie($query5)
// Don't need to parameterize the $config value.
$queries[] = "update user set session = NULL where session is not NULL and last_activity < (unix_timestamp() - {$config["session_ttl"]}) AND stay_logged_in = 0";
$queries[] = "update user set session = NULL where session is not NULL and last_activity < (unix_timestamp() - {$config["stay_logged_in_ttl"]} ) AND stay_logged_in = 1";

// NEW: older logic only deleted session and expired cookies ("(expire = -1 or expire < ".(date("U") - date("Z")).")") but now
// we clear all cookies when a user logs out so we're not hanging onto any 3rd party site credentials
// TODO: deleting from MySQL isn't wiping from disk, so the cookies table should be in-memory only (page locked)
$queries[] = "delete from cookie using cookie inner join user where cookie.user = user.id and user.session is NULL";
$queries[] = "delete from user where session is NULL and grp = '4'";
$queries[] = "delete cookie from cookie left join user on cookie.user = user.id where user.id is NULL";
//Take care of js-injection per session optouts
$queries[]="delete js_injection_session_optout from js_injection_session_optout left join user on user.session = js_injection_session_optout.psiphon_session where user.session is NULL";

foreach ($queries as $query)
{
    if (!db_query_execute($config, $query, convert_null_array(array()), true))
    {
        @unlink($config["cleanup_sessions_pid_file"]);
        sql_error_cli($query, $config["sql"]);
    }
}


@unlink($config["cleanup_sessions_pid_file"]);

exit(0);
?>
