<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Add to crontab (to have it run every 1 minute):
//
// * * * * * /usr/local/bin/php /home/ppcron/cronjobs/send_email_cron.php
//

// pwd of a cronjob seems to be the cron user's (ppcron) home directory.
// This messes up includes, so we're going to explicitly use the directory
// of this file.
$current_directory = substr($argv[0], 0, strrpos($argv[0], "/"));

//
// Sends any email waiting in email_queue. Then removes the queued entry and
// does any other resulting updates.
//
$_SERVER["DOCUMENT_ROOT"] = $current_directory;
include($current_directory."/config.php");

// Don't run if this job is already running.

if ($f = @fopen($config["send_email_pid_file"], "r"))
{
    $pid = (int)fgets($f);
    fclose($f);
    exit("{$argv[0]} is already running, pid {$pid}\n");
}

if ($f = @fopen($config["send_email_pid_file"], "w"))
{
    $pid = getmypid();
    fputs($f, $pid."\n");
    fclose($f);
}
else
{
    echo "Can't create {$config["send_email_pid_file"]}, keep running anyway.\n";
}

include($current_directory."/includes/sendmail.php");
include($current_directory."/includes/sql_error_cli.php");

// Iterate through all queued email.

$query="SELECT * FROM email_queue";

if (!($result = db_query_execute($config, $query, convert_null_array(array()), true)))
{
    @unlink($config["send_email_pid_file"]);
    sql_error_cli($query, $config['sql']);
}

while ($record=escape_smtp(db_fetch_result($config, $result, true)))
{
    // Send this email.
    
    if (!smail_plain(
            $record["recipient_email_address"],
            "",
            $config["invitation_sender"],
            "",
            "",
            $record["subject"],
            $record["body"],
            charset($record["lang"])))
    {
        echo "smail_plain failed for address: ".$record["recipient_email_address"]."\n";
    }

    // Update the invitation table to reflect that the email has been sent.
    // If this email is not an invitation, this statement will have no effect.
    // (Queued email can be for purposes other than invitations -- i.e., provisioning.)
    $query =
        "UPDATE invitation ".
        "SET status = UNIX_TIMESTAMP(), email_queue_id = NULL ".
        "WHERE email_queue_id = :email_queue_id";
    if (!db_query_execute($config, $query, convert_null_array(array(":email_queue_id" => $record['id'])), true))
    {
        @unlink($config["send_email_pid_file"]);
        sql_error_cli($query, $config[sql]);
    }

    // Delete this email from the queue.
    $query = "DELETE FROM email_queue WHERE id = :id";
    if (!db_query_execute($config, $query, convert_null_array(array(":id" => $record['id'])), true))
    {
        @unlink($config["send_email_pid_file"]);
        sql_error_cli($query, $config[sql]);
    }
}

if ($pid)
{
    @unlink($config["send_email_pid_file"]);
}

exit(0);
?>
