/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <ctype.h>
#include <http_protocol.h>
#include <http_config.h>
#include <http_log.h>
#include <apr_strings.h>
#include <apr_hash.h>
#include <apr_strmatch.h>

#include "apr_dbd.h"
#include "mod_dbd.h"
#include "psiphon_url.h"
#include "site_rules.h"

#define DEBUG
#undef DEBUG

#ifdef DEBUG
#define psiphon_headers_log(FMT, ARG...) syslog(LOG_DEBUG, "%s:%s:%d: " FMT, __FILE__, __FUNCTION__, __LINE__, ## ARG)
#else
#define psiphon_headers_log(args...)  ""
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define psiphon_headers_err_log(FMT, ARG...) syslog(LOG_ERR, "%s:%s:%d: " FMT, __FILE__, __FUNCTION__, __LINE__, ## ARG)

