#include "httpd.h"
#include "http_config.h"
#include "http_core.h"
#include "http_request.h"

#include "apr_pools.h"
#include "apr_tables.h"
#include "apr_strings.h"
#include "apr_dbd.h"
#include "mod_dbd.h"
#include "ap_regex.h"

#include <syslog.h>
#include <stdlib.h>

#define jsf_err_log(args...) syslog(LOG_ERR, args)

#define DEBUG
#undef DEBUG

#ifdef DEBUG
#define jsf_log(args...) syslog(LOG_DEBUG, args)
#else
#define jsf_log(args...)  ""
#endif

#define JSF_LAST_RULE 128

typedef struct {
    char *replace;
    char *search;
    int flags;
    ap_regex_t *regex;
} regs_v_t;

const char *jsf_interpolate_vars(request_rec* r, const char* str);
const char * escape_regex_symbols(apr_pool_t *p, const char *s);
const char *jsf(request_rec *r, regs_v_t **regs_v, const char *buf, size_t len);
regs_v_t **jsf_init(request_rec *r);


