#include <syslog.h>
#include <apr.h>
#include <apr_lib.h>
#include <apr_strings.h>
#include <apr_pools.h>
#include <apr_uri.h>


#define CHAR_HEX_ESCAPE '%'
#define CHAR_ACCEPTABLE(a)  (a >= 32 && a < 128 && (psi_uri_acceptable_chars[a - 32] & mask))
#define FROMASCII(c) (c)

#define DEBUG
#undef DEBUG

#ifdef DEBUG
#define psiphon_url_log(args...) syslog(LOG_DEBUG, args)
#else
#define psiphon_url_log(args...) ""
#endif


char* psi_rawurl_encode (apr_pool_t* pool, char *str);
char* psi_rawurl_decode (char * str);
char* psi_url_encode (apr_pool_t* pool, char *str);
int psi_uri_has_scheme(const char* uri);
char* psi_merge_url(apr_pool_t* pool, const char* url, const char* base);
int psi_url_path_length(const char* url);
char* psi_simplify_uri(apr_pool_t* pool, const char* str);
char* psi_proxify_url(apr_pool_t* pool, const char* url,  const char* base);
void psi_path_simplify (char *path);
char* psi_strndup(const char *str, size_t len);

