-- MySQL dump 10.13  Distrib 5.1.36, for portbld-freebsd6.3 (i386)
--
-- Host: localhost    Database: psiphon
-- ------------------------------------------------------
-- Server version	5.1.36
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO,MYSQL323' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `anonymous_browsing`
--

DROP TABLE IF EXISTS `anonymous_browsing`;
CREATE TABLE `anonymous_browsing` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `token` char(32) NOT NULL DEFAULT '',
  `home_page` char(255) NOT NULL DEFAULT '',
  `home_page_locked` int(1) NOT NULL DEFAULT '0',
  `lang` char(2) NOT NULL DEFAULT 'en',
  `proxy` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) TYPE=MyISAM AUTO_INCREMENT=48;

--
-- Table structure for table `bookmark`
--

DROP TABLE IF EXISTS `bookmark`;
CREATE TABLE `bookmark` (
  `user` int(11) NOT NULL DEFAULT '0',
  `url` char(255) binary NOT NULL DEFAULT '',
  `title` char(64) DEFAULT '',
  PRIMARY KEY (`user`,`url`)
) TYPE=MyISAM;

--
-- Table structure for table `cookie`
--

DROP TABLE IF EXISTS `cookie`;
CREATE TABLE `cookie` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL DEFAULT '0',
  `domain` char(64) DEFAULT '',
  `path` char(255) binary DEFAULT '',
  `name` char(160) DEFAULT '',
  `value` text,
  `expire` int(11) DEFAULT '0',
  `secure` int(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_user` (`user`,`domain`,`path`,`name`)
) TYPE=MyISAM AUTO_INCREMENT=4527055;

--
-- Table structure for table `email_queue`
--

DROP TABLE IF EXISTS `email_queue`;
CREATE TABLE `email_queue` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `recipient_email_address` char(64) NOT NULL DEFAULT '',
  `subject` char(64) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `lang` char(2) NOT NULL DEFAULT 'en',
  PRIMARY KEY (`id`)
) TYPE=MyISAM AUTO_INCREMENT=7286;

--
-- Table structure for table `invitation`
--

DROP TABLE IF EXISTS `invitation`;
CREATE TABLE `invitation` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` int(11) DEFAULT '0',
  `user` int(11) DEFAULT '0',
  `proxy` int(11) DEFAULT '0',
  `pass` char(9) DEFAULT '',
  `email` char(64) DEFAULT '',
  `status` int(11) DEFAULT '0',
  `url` char(128) DEFAULT '',
  `lang` char(2) DEFAULT '',
  `email_queue_id` int(11) DEFAULT '0',
  `grp` int(1) DEFAULT '3',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_pass` (`pass`),
  KEY `idx_date` (`date`)
) TYPE=MyISAM AUTO_INCREMENT=5201;

--
-- Table structure for table `jsf`
--

DROP TABLE IF EXISTS `jsf`;
CREATE TABLE `jsf` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ord` int(11) DEFAULT '0',
  `domain` char(64) DEFAULT '',
  `path` char(255) DEFAULT '',
  `srch` text,
  `repl` text,
  `flags` int(2) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_proxy_ord` (`ord`)
) TYPE=MyISAM AUTO_INCREMENT=59;

--
-- Table structure for table `proxy`
--

DROP TABLE IF EXISTS `proxy`;
CREATE TABLE `proxy` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` char(64) NOT NULL DEFAULT 'Proxy',
  `notes` text NOT NULL,
  `hostname` char(64) NOT NULL DEFAULT '',
  `addr` int(11) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_addr` (`addr`)
) TYPE=MyISAM AUTO_INCREMENT=84;

--
-- Table structure for table `stat_account_created`
--

DROP TABLE IF EXISTS `stat_account_created`;
CREATE TABLE `stat_account_created` (
  `date` int(11) NOT NULL,
  `region` char(2) NOT NULL,
  `proxy` int(11) NOT NULL,
  `proxy_notes` text NOT NULL,
  `grp` int(11) NOT NULL,
  `cnt` int(11) DEFAULT '0',
  PRIMARY KEY (`date`,`region`,`proxy`,`grp`)
) TYPE=MyISAM;

--
-- Table structure for table `stat_blue_bar_submit`
--

DROP TABLE IF EXISTS `stat_blue_bar_submit`;
CREATE TABLE `stat_blue_bar_submit` (
  `date` int(11) NOT NULL,
  `domain` char(48) NOT NULL,
  `region` char(2) NOT NULL,
  `proxy` int(11) NOT NULL,
  `proxy_notes` text NOT NULL,
  `grp` int(11) NOT NULL,
  `cnt` int(11) DEFAULT '0',
  PRIMARY KEY (`date`,`domain`,`region`,`proxy`,`grp`)
) TYPE=MyISAM;

--
-- Table structure for table `stat_region`
--

DROP TABLE IF EXISTS `stat_region`;
CREATE TABLE `stat_region` (
  `date` int(11) NOT NULL DEFAULT '0',
  `region` char(2) NOT NULL DEFAULT '',
  `proxy` int(11) NOT NULL DEFAULT '0',
  `cnt` int(11) DEFAULT '0',
  `grp` int(1) NOT NULL DEFAULT '3',
  `proxy_notes` text NOT NULL,
  PRIMARY KEY (`date`,`region`,`proxy`,`grp`)
) TYPE=MyISAM;

--
-- Table structure for table `stat_site`
--

DROP TABLE IF EXISTS `stat_site`;
CREATE TABLE `stat_site` (
  `date` int(11) NOT NULL DEFAULT '0',
  `domain` char(48) NOT NULL DEFAULT '',
  `region` char(2) NOT NULL DEFAULT '',
  `proxy` int(11) NOT NULL DEFAULT '0',
  `cnt` int(11) DEFAULT '0',
  `grp` int(1) NOT NULL DEFAULT '3',
  `proxy_notes` text NOT NULL,
  PRIMARY KEY (`date`,`domain`,`region`,`proxy`,`grp`)
) TYPE=MyISAM;

--
-- Table structure for table `ticket`
--

DROP TABLE IF EXISTS `ticket`;
CREATE TABLE `ticket` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) DEFAULT '0',
  `last_user` varchar(99) DEFAULT '',
  `last_date` int(11) DEFAULT '0',
  `closed` int(1) DEFAULT '0',
  `title` varchar(80) DEFAULT '',
  `body` blob,
  PRIMARY KEY (`id`),
  KEY `idx_user_closed` (`user`,`closed`),
  KEY `idx_closed` (`closed`)
) TYPE=MyISAM AUTO_INCREMENT=123;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
CREATE TABLE `user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `email` char(64) DEFAULT '',
  `pass` char(40) DEFAULT '',
  `uname` char(32) DEFAULT '',
  `session` char(32) DEFAULT '',
  `last` int(11) DEFAULT '0',
  `last_reg` char(2) DEFAULT '',
  `last_lang` char(2) DEFAULT '',
  `grp` int(1) DEFAULT '0',
  `proxy` int(11) DEFAULT '0',
  `xml_html` int(1) DEFAULT '1',
  `locked` int(1) DEFAULT '0',
  `created` int(11) DEFAULT '0',
  `invited` int(11) DEFAULT '0',
  `inv_sent` int(11) DEFAULT '0',
  `inv_actv` int(11) DEFAULT '0',
  `home_page` char(255) DEFAULT '',
  `home_page_locked` int(1) NOT NULL DEFAULT '0',
  `last_activity` int(11) NOT NULL DEFAULT '0',
  `consecutive_failed_logins` int(11) NOT NULL DEFAULT '0',
  `login_delay` int(11) NOT NULL DEFAULT '0',
  `email_candidate` char(64) DEFAULT NULL,
  `email_candidate_token` char(32) DEFAULT NULL,
  `email_candidate_date` int(11) DEFAULT NULL,
  `welcome_email_sent` int(1) NOT NULL DEFAULT '0',
  `agreed_to_usage_terms` int(1) NOT NULL DEFAULT '0',
  `csrf_token` char(32) DEFAULT NULL,
  `last_token_count` int(11) NOT NULL DEFAULT '0',
  `last_token_accrual_time` int(11) DEFAULT NULL,
  `pass_salt` char(32) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_session` (`session`),
  UNIQUE KEY `idx_email` (`email`),
  UNIQUE KEY `idx_name` (`uname`)
) TYPE=MyISAM AUTO_INCREMENT=98214;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-09-03 14:33:07
