/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

-- MySQL dump 10.13
--
-- Host: localhost    Database: psiphon
-- ------------------------------------------------------
-- Server version	5.1.22-rc
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO,MYSQL323' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `bookmark`
--

DROP TABLE IF EXISTS `bookmark`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `bookmark` (
  `user` int(11) NOT NULL DEFAULT '0',
  `url` char(255) binary NOT NULL DEFAULT '',
  `title` char(64) DEFAULT '',
  PRIMARY KEY (`user`,`url`)
) TYPE=MyISAM;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `cookie`
--

DROP TABLE IF EXISTS `cookie`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `cookie` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL DEFAULT '0',
  `domain` char(64) DEFAULT '',
  `path` char(255) binary DEFAULT '',
  `name` char(160) DEFAULT '',
  `value` text,
  `expire` int(11) DEFAULT '0',
  `secure` int(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_user` (`user`,`domain`,`path`,`name`)
) TYPE=MyISAM AUTO_INCREMENT=249595;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `folder`
--

DROP TABLE IF EXISTS `folder`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `folder` (
  `user` int(11) NOT NULL DEFAULT '0',
  `folder` int(11) NOT NULL DEFAULT '0',
  `cnt` int(11) DEFAULT '0',
  PRIMARY KEY (`user`,`folder`)
) TYPE=MyISAM;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `invitation`
--

DROP TABLE IF EXISTS `invitation`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `invitation` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` int(11) DEFAULT '0',
  `user` int(11) DEFAULT '0',
  `proxy` int(11) DEFAULT '0',
  `pass` char(9) DEFAULT '',
  `email` char(64) DEFAULT '',
  `status` int(11) DEFAULT '0',
  `url` char(128) DEFAULT '',
  `lang` char(2) DEFAULT '',
  `subject` char(64) DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_pass` (`pass`),
  KEY `idx_date` (`date`)
) TYPE=MyISAM AUTO_INCREMENT=901;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `jsf`
--

DROP TABLE IF EXISTS `jsf`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `jsf` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ord` int(11) DEFAULT '0',
  `domain` char(64) DEFAULT '',
  `path` char(255) DEFAULT '',
  `srch` text,
  `repl` text,
  `flags` int(2) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_proxy_ord` (`ord`)
) TYPE=MyISAM AUTO_INCREMENT=48;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `msg`
--

DROP TABLE IF EXISTS `msg`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `msg` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `owner` int(11) DEFAULT '0',
  `folder` int(1) DEFAULT '0',
  `addr` int(11) DEFAULT '0',
  `date` int(11) DEFAULT '0',
  `body` char(255) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_owner` (`owner`,`folder`)
) TYPE=MyISAM AUTO_INCREMENT=183;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `mtype`
--

DROP TABLE IF EXISTS `mtype`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `mtype` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `proxy` int(11) DEFAULT '0',
  `val` char(64) DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_proxy_type` (`proxy`,`val`)
) TYPE=MyISAM AUTO_INCREMENT=6;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `proxy`
--

DROP TABLE IF EXISTS `proxy`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `proxy` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `addr` int(11) DEFAULT '0',
  `vlists` char(255) DEFAULT '',
  `body` text,
  `welcome` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_addr` (`addr`)
) TYPE=MyISAM AUTO_INCREMENT=38;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `stat_region`
--

DROP TABLE IF EXISTS `stat_region`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `stat_region` (
  `date` int(11) NOT NULL DEFAULT '0',
  `region` char(2) NOT NULL DEFAULT '',
  `proxy` int(11) NOT NULL DEFAULT '0',
  `cnt` int(11) DEFAULT '0',
  PRIMARY KEY (`date`,`region`,`proxy`)
) TYPE=MyISAM;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `stat_site`
--

DROP TABLE IF EXISTS `stat_site`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `stat_site` (
  `date` int(11) NOT NULL DEFAULT '0',
  `domain` char(48) NOT NULL DEFAULT '',
  `region` char(2) NOT NULL DEFAULT '',
  `proxy` int(11) NOT NULL DEFAULT '0',
  `cnt` int(11) DEFAULT '0',
  PRIMARY KEY (`date`,`domain`,`region`,`proxy`)
) TYPE=MyISAM;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `ticket`
--

DROP TABLE IF EXISTS `ticket`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `ticket` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) DEFAULT '0',
  `last_user` varchar(99) DEFAULT '',
  `last_date` int(11) DEFAULT '0',
  `closed` int(1) DEFAULT '0',
  `title` varchar(80) DEFAULT '',
  `body` blob,
  PRIMARY KEY (`id`),
  KEY `idx_user_closed` (`user`,`closed`),
  KEY `idx_closed` (`closed`)
) TYPE=MyISAM AUTO_INCREMENT=32;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `email` char(64) DEFAULT '',
  `pass` char(32) DEFAULT '',
  `uname` char(32) DEFAULT '',
  `session` char(32) DEFAULT '',
  `last` int(11) DEFAULT '0',
  `last_reg` char(2) DEFAULT '',
  `last_lang` char(2) DEFAULT '',
  `grp` int(1) DEFAULT '0',
  `proxy` int(11) DEFAULT '0',
  `crpt_url` int(1) DEFAULT '0',
  `xml_html` int(1) DEFAULT '1',
  `feedback` int(1) DEFAULT '0',
  `msgs` int(11) DEFAULT '0',
  `sent` int(1) DEFAULT '0',
  `msg_ppage` int(2) DEFAULT '20',
  `locked` int(1) DEFAULT '0',
  `created` int(11) DEFAULT '0',
  `invited` int(11) DEFAULT '0',
  `inv_sent` int(11) DEFAULT '0',
  `inv_actv` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_session` (`session`),
  UNIQUE KEY `idx_email` (`email`),
  UNIQUE KEY `idx_name` (`uname`)
) TYPE=MyISAM AUTO_INCREMENT=394;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `vgroup`
--

DROP TABLE IF EXISTS `vgroup`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `vgroup` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` char(32) DEFAULT '',
  `proxy` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) TYPE=MyISAM AUTO_INCREMENT=30;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `vlist`
--

DROP TABLE IF EXISTS `vlist`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `vlist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `grp` int(11) DEFAULT '0',
  `domain` char(64) DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_grp_dmn` (`grp`,`domain`)
) TYPE=MyISAM AUTO_INCREMENT=1231;
SET character_set_client = @saved_cs_client;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-02-26 22:05:46
