--
-- Modifications to table useragent for handling compatibility mode exit link
--
ALTER TABLE useragent ADD back_link text;

ALTER TABLE `user` ADD COLUMN `pass_reset_token` CHAR(32) DEFAULT '' NOT NULL;
ALTER TABLE `user` ADD COLUMN `pass_reset_date` INTEGER DEFAULT 0 NOT NULL;
ALTER TABLE `user` ADD COLUMN `stay_logged_in` INTEGER  NOT NULL DEFAULT 0;

--
-- Modifications to table proxy(add propagator notes field)
--
ALTER TABLE proxy ADD COLUMN propagator_notes text  NOT NULL AFTER notes;

ALTER TABLE `invitation` ADD COLUMN `homepage` CHAR(255);

CREATE TABLE `js_injection` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`description` char(255) DEFAULT NULL,
`valid_from` int(11) DEFAULT NULL,
`valid_to` int(11) DEFAULT NULL,
`notes` char(255) DEFAULT NULL,
`injection_code` text NOT NULL,
PRIMARY KEY (`id`)
); 
CREATE INDEX idx_valid_from ON js_injection (valid_from);
CREATE INDEX idx_valid_to ON js_injection (valid_to);
CREATE INDEX idx_description ON js_injection (description);
CREATE INDEX idx_notes ON js_injection (notes);

--
-- JS injection related tables
--
CREATE TABLE `js_injection_proxy` (
`js_injection_id` int(11) NOT NULL DEFAULT '0',
`proxy_id` int(11) NOT NULL DEFAULT '0',
PRIMARY KEY (`js_injection_id`,`proxy_id`)
);

CREATE TABLE `js_injection_user_optout` (
`created` int(11) NOT NULL DEFAULT '0',
`js_injection_id` int(11) NOT NULL DEFAULT '0',
`user_id` int(11) NOT NULL DEFAULT '0',
PRIMARY KEY (`js_injection_id`,`user_id`)
);

CREATE TABLE `js_injection_session_optout` (
`created` int(11) NOT NULL DEFAULT '0',
`js_injection_id` int(11) NOT NULL DEFAULT '0',
`psiphon_session` char(32) NOT NULL DEFAULT '',
PRIMARY KEY (`js_injection_id`,`psiphon_session`)
);

--
-- Add SSH server fingerprint column to proxy table
--

ALTER TABLE proxy ADD http_proxy_port_number int(11) DEFAULT 0;
ALTER TABLE proxy ADD ssh_server_port_number int(11) DEFAULT 0;
ALTER TABLE proxy ADD ssh_server_fingerprint char(100) DEFAULT '';
ALTER TABLE proxy ADD ssh_user_name char(100) DEFAULT '';
ALTER TABLE proxy ADD ssh_user_password char(100) DEFAULT '';

--
-- Create table for PsiphonX download count stats
--

CREATE TABLE stat_client_download (
    date int(11) NOT NULL DEFAULT 0,
    region char(2) NOT NULL DEFAULT '',
    proxy int(11) NOT NULL DEFAULT 0,
    total int(11) DEFAULT 0,
    PRIMARY KEY (date, region, proxy)
);

