#!/bin/sh

echo "Performing DB installation ..."
if [ ! -n "${mysql_pass+x}" ] ; then
   echo "Enter mysql 'psiphon' user password"
   tty_mode=`stty -g`
   stty -echo
   read mysql_pass
   stty ${tty_mode}
   echo
fi

#create 'grant permissions' sql script
cat sql/grant.sql | sed "s/#psiphon_mysql_password#/${mysql_pass}/" > sql/grant.new.sql

# get mysql:root password ###################################################
echo "Enter current password for mysql root (Press 'Enter' for none)"

tty_mode=`stty -g`
stty -echo
read mysql_root_pass
stty ${tty_mode}
echo
export mysql_root_pass

if [ -n "${mysql_root_pass}" ]; then 
    pass_string=" -p${mysql_root_pass}"
else    
pass_string=""
fi

echo "Creating 'psiphon' database and 'psiphon' mysql user"
cat sql/create_db.sql sql/grant.new.sql | mysql -uroot ${pass_string}

echo "Creating initial baseline database schema" 
cat sql/structure.2.3.sql | mysql -uroot ${pass_string} psiphon

echo "Creating 'db_schema_version' table"
cat sql/db_schema_version.sql | mysql -uroot ${pass_string} psiphon

echo "Creating default 'admin' user" 
cat sql/init.sql | mysql -uroot ${pass_string} psiphon

echo "Creating JS filter rules"
cat sql/jsf.sql sql/site-compat/*.sql | mysql -uroot ${pass_string} psiphon

./tools/db_upgrade.sh upgrade

#need to run this one after db upgrade
echo "Creating 'redirect to mobile' rules"
cat sql/useragents.sql| mysql -uroot ${pass_string} psiphon

unset mysql_root_pass

rm sql/grant.new.sql

echo "DB installation done."
