<?php
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include_once($_SERVER[DOCUMENT_ROOT]."/includes/cr.php");
include_once($_SERVER[DOCUMENT_ROOT]."/includes/url_extract_helpers.php");
include_once($_SERVER[DOCUMENT_ROOT]."/includes/utf8_encode.php");

if ((int)$_SERVER["REDIRECT_psiphon_uid"]) {
   $_SERVER["psiphon_uid"] = $_SERVER["REDIRECT_psiphon_uid"];
}
if (!($uid = (int)$_SERVER["psiphon_uid"])) {
    exit(0);
}

// Get login_url for this proxy for use in logout link
// This code is adapted from chk.php

$query = "SELECT * FROM proxy WHERE hostname = :hostname";
$result = db_query_execute($config, $query, convert_null_array(array(":hostname" => $_SERVER[HTTP_HOST])));
$proxy_record = db_fetch_result($config, $result);

if (!$proxy_record)
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/404.php");
}

$login_url = $proxy_record['login_url'];

$record_user = lookup_user($config, "user.id = :user_id", array(":user_id" => $uid));

if (!$record_user)
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
}

if (!($prefix = (string)$_SERVER["psiphon_html_prefix"])) {
    exit(0);
}

$uri = $_SERVER["psiphon_proxy_uri"];

if(!$uri) {
    $uri = $_SERVER["REDIRECT_psiphon_proxy_uri"];
}

if ($uri && !(!strncmp($uri, "ftp://", 6) ||
              !strncmp($uri, "http://", 7) ||
              !strncmp($uri, "https://", 8))) {
    $uri="";
}
?>

<!--bluebar-->
<link type="text/css" rel="stylesheet" href="/css/bluebar.css"/>
<div id="psibluebar" style="position:absolute; right:0px; top:0px; left:0px; white-space:nowrap; padding:3px; background:#DDDDFF;  border:1px solid #115599; z-index:999999;">
<form action="/redirect.php" method="get" target="_top" id="psiform">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td valign="bottom">
<input name="csrf_token" value="<?=$record_user['csrf_token']?>" type="hidden"/>
<?=utf8_encode_string(___("URL:"))?>
</td>
<td valign="bottom" style="width: 100%;">
<!-- // IMPORTANT: Do not change the id of psiphon_url_display.  This is referenced in other files, including bluebar.js for stats. -->
<input type="text" style="width: 100%;" id="psiphon_url_display" name="psiphon_url_display" value="<?=htmlentities($uri, ENT_QUOTES, charset())?>"/>
</td>
<td valign="bottom">
<input type="hidden" name="url" value=""/>
<input type="submit" value="<?=utf8_encode_string(___("GO"))?>"/>
<?
echo $v;

// add download link if this proxy has SSH configuration

if (strlen($proxy_record['ssh_server_fingerprint']) > 0 &&
    strlen($proxy_record['ssh_user_name']) > 0 &&
  strlen($proxy_record['ssh_user_password']) > 0)
{
    if ($record_user['last_lang'] == "fa")
    {
        $download_url = "/psiphonx_fa.php?url=".urlencode(getenv("psiphon_proxy_uri"));
        echo "<a style=\"color:red; font-weight:bold\" href=\"$download_url\">".utf8_encode_string("سایفون اکس - جدید")."</a> | ";
    }
    else
    {
        $download_url = "/psiphonx.php?url=".urlencode(getenv("psiphon_proxy_uri"));
        echo "<a style=\"color:red; font-weight:bold\" href=\"$download_url\">New! Try PsiphonX</a> | ";
    }
}

// Indicate custom user agent, if it configured for the proxied URL

if (isset($_SERVER["psiphon_custom_user_agent"]) && isset($_SERVER["psiphon_custom_user_agent_back_link"])) {
    echo "<a href=\"".$prefix."/".$_SERVER["psiphon_custom_user_agent_back_link"]."\" target=\"_top\">".utf8_encode_string(___("Exit Compatibility Mode"))."</a> |\n";    
}

// Add link create for Anonymous Users

if (is_anonymous_user($record_user))
{
    echo "<a href=\"/anon_create.php\" target=\"_top\">".utf8_encode_string(___("Create account"))."</a> |\n";
}

$bookmark_url = "/bookmarks.php?ret=".urlencode(getenv("REQUEST_URI"));

if ($_SERVER["psiphon_proxy_uri"])
{
    // Add link to add-ticket if user has permission

    if (user_has_permission($config, $record_user, "send_ticket"))
    {
        echo "<a href=\"/ticket-add.php?url=".urlencode($_SERVER["psiphon_proxy_uri"])."&amp;ret=".urlencode(getenv("REQUEST_URI"))."\" target=\"_top\">".utf8_encode_string(___("Broken page"))."</a> |\n";
    }

    $bookmark_url = "/bookmarks.php?bookmark_url=".urlencode($_SERVER["psiphon_proxy_uri"])."&amp;ret=".urlencode(getenv("REQUEST_URI"));
}

// Add link to bookmarks if user has permission

if (user_has_permission($config, $record_user, "bookmarks"))
{
    echo "<a href=\"$bookmark_url\" target=\"_top\">".utf8_encode_string(___("Bookmark"))."</a> |\n";
}

// Add link to profile if user has permission

if (user_has_permission($config, $record_user, "profile"))
{
    echo "<a href=\"/profile.php\" target=\"_top\">".utf8_encode_string(___("Profile"))."</a> |\n";
}

// Add link to profile if user has permission

if (user_has_permission($config, $record_user, "invite")
    && ($record_user['invite_token_count'] > 0 || $record_user['invite_token_count'] == Null))
{
    echo "<a href=\"/invite-m.php\" target=\"_top\">".utf8_encode_string(___("Invite"))."</a> ";

    // Don't show the token count if the user has infinite tokens.
    if ($record_user['invite_token_count'] != Null)
    {
        echo utf8_encode_string(sprintf(___("(%d remaining)"), $record_user['invite_token_count']));
    }

    echo " |\n";
}

// Add link to logout if user has permission

if (user_has_permission($config, $record_user, "logout"))
{
    if(isset($_SERVER["REDIRECT_psiphon_login_url"]))
    {
        $_SERVER["psiphon_login_url"] = $_SERVER["REDIRECT_psiphon_login_url"];
    }
    echo "<a href=\"/logout.php?lu={$login_url}\" target=\"_top\">".utf8_encode_string(___("Logout"))."</a>\n";
}

?>
<span id="psipagecounter"></span>
<a href="#" onclick="move_up();return false;">/\</a> <a href="#" onclick="move_down();return false;">\/</a></td>
</tr>
</table>
</form>
</div>
<span id="psipagecounter"></span>
<?/* The "bust" GET parameter is used to ensure that the page is never cached. */?>
<script type="text/javascript" src="/js/bluebar.js"></script>

<?
/*  -- Disabled until translated
// Guest users are prompted to sign-up for real accounts every so often

if(is_anonymous_user($record_user))
{
    ?>
<div id="guestSignUpPrompt" style="background: white none repeat scroll 0% 0%; top: 0px; left: 0px; display: none; position: absolute; width: 100%; height: 100%;  z-index: 999998; opacity: 0.9;">
<center style="position:relative; top: 200px">
<h2>
<?=sprintf(___("To continue to receiving free, uncensored access consider signing up for a Psiphon account.  In the event that this proxy is blocked, you will receive notification of another way to connect to Psiphon.  Use the <a href=\"%s\">Create Account</a> link to create your account now!"), "/anon_create.php")?>
<br>
<br>
<a href="#" onClick="HideGuestSignUpPrompt();"><?=___("No thanks, keep browsing.")?></a>
</h2>
</center>
</div>
<script type="text/javascript" src="/js/guest_signup.js"></script>
    <?
}
*/
?>
<?php
include_once($_SERVER[DOCUMENT_ROOT]."/js-injection/inject.php");
?>

