<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

$config = array();

$config["no_proxy"] = 0;

include($_SERVER[DOCUMENT_ROOT]."/includes/db.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/clean_meta.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang.php");
//include_once($_SERVER[DOCUMENT_ROOT]."/includes/user_class_helpers.php");

$config[db_host] = "localhost";
$config[db_user] = "psiphon";
$config[db_pass] = "#psiphon_mysql_password#";
$config[db_name] = "psiphon";

$config['sql'] = db_connect($config);


if ($_SERVER["HTTPS"]) {
    $config["ret"]="https://";
} else {
    $config["ret"]="http://";
}

$config["ret"] .= getenv("HTTP_HOST").
                  substr(getenv("SCRIPT_NAME"), 0,
                         strrpos(getenv("SCRIPT_NAME"), "/"));

$config["seconds_in_day"] = 86400; // seconds: 86400 * days

// invitation is valid for 5 days, then it's deleted if not used
$config["invitation_ttl"] = 86400 * 5; // seconds: 86400 * days

// email candidate is valid for 5 days, then it's deleted if not verified
$config["email_candidate_ttl"] = 86400 * 5;

// user can change own email at most once per hour
$config["email_change_period"] = 60*60;

$config["session_ttl"] = 60*60; // session expires after 1 idle hour

// Period to stay logged in
$config['stay_logged_in_ttl'] = 2 * 7 * 24 * 60 * 60; // 2 weeks

// unused non-disabled user accounts are deleted after 2 years of inactivity
$config["unused_account_ttl"] = 86400 * 365 * 2;

// unused disabled user accounts are deleted after 5 months since disabled
$config["unused_disabled_account_ttl"] = 86400 * 30 * 5;

// user groups/classes affected by automatic unused account cleanup
// hardcoded values to avoid function calls
// Values correspond to: power_user_class_id, normal_user_class_id, 
// anonymous_user_class_id, propagator_user_class_id, reporter_user_class_id
$config["unused_account_cleanup_affected_user_classes"] = array("2", "3", "4", "6", "7");
//$config["unused_account_cleanup_affected_user_classes"] = array(get_power_user_class_id(), 
//    get_normal_user_class_id(), get_anonymous_user_class_id(),
//    get_propagator_user_class_id(), get_reporter_user_class_id() );

$config[min_pass_length] = 6;
$config[max_login_delay] = 30; // 30 seconds

$config['tickets_ppage'] = 20;
$config['users_ppage'] = 100;

$config["sender"] = "psiphonadmin@gmail.com";
$config["invitation_sender"] = "psiphonadmin@gmail.com";

$config["send_email_pid_file"] = "/var/run/ppcron/psiphon_send_email.pid";
$config["cleanup_email_candidates_pid_file"] = "/var/run/ppcron/psiphon_cleanup_email_candidates.pid";
$config["cleanup_invitations_pid_file"] = "/var/run/ppcron/psiphon_cleanup_invitations.pid";
$config["cleanup_sessions_pid_file"] = "/var/run/ppcron/psiphon_cleanup_sessions.pid";
$config["cleanup_unused_accounts_pid_file"] = "/var/run/ppcron/psiphon_cleanup_unused_accounts.pid";

$config["psiphon_web_resource_page"] = "https://docs.google.com/View?id=dccxjzk4_0f76vf8g8";

$config[title] = "psiphon";

$config["folder_last"] = 1; // max folder id
$config["folder_inbox"] = 0;
$config["folder_sent"] = 1;

$config['perm'] =
    array(
        'invite'            => 1<<1,
        'other_nodes'       => 1<<2,
        'accounts'          => 1<<3,
        'proxies'           => 1<<4,
        'manage_ticket'     => 1<<5,
        'jsf'               => 1<<6,
        'reports'           => 1<<7,
        'anonymous'         => 1<<8,
        'profile'           => 1<<9,
        'send_ticket'       => 1<<10,
        'bookmarks'         => 1<<11,
        'logout'            => 1<<12,
        // If the names of these permissions are changed, can_class_manage_class will need to be updated.
        'can_grant_grp_0'   => 1<<13,
        'can_grant_grp_2'   => 1<<14,
        'can_grant_grp_3'   => 1<<15,
        'can_grant_grp_4'   => 1<<16,
        'can_grant_grp_6'   => 1<<17,
        'can_grant_grp_7'   => 1<<18,
        'view_propagator_info' => 1<<19,
        'multi_proxy'       => 1<<20,
        'custom_user_agents' => 1<<21,
        'delete_account'    => 1 << 22, 
        'stay_logged_in'    => 1<<23,
        'can_inject_js'     => 1<<24,
    );

// This defines the order in which the user groups/classes should be displayed. Generally, least-to-highest privilege.
$config['grp_order'] = array(4, 3, 2, 6, 7, 0);

$config['grp'] = array(

    // Note that 1 and 5 are missing from this array. They were Node Admin and
    // Node Host. They were removed when the Propagator class was added.
    // The reason we don't reuse user class ID numbers is that if the upgrade
    // script is re-run, we don't want to accidentally delete/modify any users
    // that aren't actually of the old class.

    // Admin

    0 => $config['perm']['invite']
       | $config['perm']['other_nodes']
       | $config['perm']['proxies']
       | $config['perm']['accounts']
       | $config['perm']['jsf']
       | $config['perm']['reports']
       | $config['perm']['manage_ticket']
       | $config['perm']['anonymous']
       | $config['perm']['profile']
       | $config['perm']['send_ticket']
       | $config['perm']['bookmarks']
       | $config['perm']['logout']
       | $config['perm']['can_grant_grp_0']
       | $config['perm']['can_grant_grp_2']
       | $config['perm']['can_grant_grp_3']
       | $config['perm']['can_grant_grp_6']
       | $config['perm']['can_grant_grp_7']
       | $config['perm']['custom_user_agents']
       | $config['perm']['can_inject_js'],

    // Power User

    2 => $config['perm']['invite']
       | $config['perm']['profile']
       | $config['perm']['send_ticket']
       | $config['perm']['bookmarks']
       | $config['perm']['logout']
       | $config['perm']['can_grant_grp_3']
       | $config['perm']['stay_logged_in']
       | $config['perm']['delete_account'],

    // User
    // NOTE: '3' is the grp default in the invitation table. So if the 3 changes here, it'll have to change there.

    3 => $config['perm']['invite']
       | $config['perm']['profile']
       | $config['perm']['send_ticket']
       | $config['perm']['bookmarks']
       | $config['perm']['logout']
       | $config['perm']['can_grant_grp_3']
       | $config['perm']['stay_logged_in']
       | $config['perm']['delete_account'],

    // Anonymous User

    4 => $config['perm']['logout'],

    // Propagator

    6 => $config['perm']['profile']
       | $config['perm']['send_ticket']
       | $config['perm']['bookmarks']
       | $config['perm']['logout']
       | $config['perm']['can_grant_grp_2']
       | $config['perm']['can_grant_grp_3']
       | $config['perm']['invite']
       | $config['perm']['view_propagator_info']
       | $config['perm']['multi_proxy']
       | $config['perm']['delete_account'],

    // Reporter

    7 => $config['perm']['profile']
       | $config['perm']['logout']
       | $config['perm']['reports']
       | $config['perm']['other_nodes']
       | $config['perm']['delete_account'],
);

/*
 * The array index is the user class (group) ID.
 * token_accrual_period_in_hours: The number of hours in each accrual period. May be float.
 * token_accrual_rate_per_period: The number of tokens accrued per period. MUST BE INTEGER.
 * max_tokens: The max number of tokens that may be accrued.
 * delay_until_accrual_starts_in_hours: The number of hours that must pass before
 *      the user starts accruing any tokens.
 */
$config['grp_invite_token_settings'] = array(

    // Admin: infinite
    0 => array( "token_accrual_period_in_seconds" => 1.0 * 60 * 60,
                "token_accrual_rate_per_period" => 1,
                "max_tokens" => 10,
                "delay_until_accrual_starts_in_seconds" => 24 * 60 * 60,
                "infinite_tokens" => 1 ),

    // Power User: infinite
    2 => array( "token_accrual_period_in_seconds" => 1.0 * 60 * 60,
                "token_accrual_rate_per_period" => 1,
                "max_tokens" => 10,
                "delay_until_accrual_starts_in_seconds" => 24 * 60 * 60,
                "infinite_tokens" => 1 ),

    // User: 1 per 1 day, max 20, no delay
    3 => array( "token_accrual_period_in_seconds" => 24 * 60 * 60,
                "token_accrual_rate_per_period" => 1,
                "max_tokens" => 20,
                "delay_until_accrual_starts_in_seconds" => 0,
                "infinite_tokens" => 0 ),

    // Anonymous user. No invite tokens.
    4 => array( "token_accrual_period_in_seconds" => 0,
                "token_accrual_rate_per_period" => 0,
                "max_tokens" => 0,
                "delay_until_accrual_starts_in_seconds" => 0,
                "infinite_tokens" => 0 ),

    // Propagator: infinite
    6 => array( "token_accrual_period_in_seconds" => 1.0 * 60 * 60,
                "token_accrual_rate_per_period" => 1,
                "max_tokens" => 10,
                "delay_until_accrual_starts_in_seconds" => 24 * 60 * 60,
                "infinite_tokens" => 1 ),

    // Reporter. No invite tokens.
    7 => array( "token_accrual_period_in_seconds" => 0,
                "token_accrual_rate_per_period" => 0,
                "max_tokens" => 0,
                "delay_until_accrual_starts_in_seconds" => 0,
                "infinite_tokens" => 0 ),

);

$config["name_key"]="idx_name";


/*
GeoIP data file and its version  (City vs Country)

See:
http://geolite.maxmind.com/download/geoip/api/php/sample_city.php
http://geolite.maxmind.com/download/geoip/api/php/sample.php

*/

//$config["geoip_type"] = "city";
//$config["geoip_data_file"] = "/usr/local/share/GeoIP/GeoIP.dat";

$config["geoip_type"]= "country";
$config["geoip_data_file"] = "/usr/share/GeoIP/GeoIP.dat";

// Password reset
// 3 days
$config['password_reset_ttl'] = 7 * 24 * 60 * 60;

//A hack for xgettext extraction utility
$config['lang'] = array(
    'en' => array('title'=>___("English", NULL, "en"), 'translated_title'=>"English", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'fa' => array('title'=>___("Persian", NULL, "en"), 'translated_title'=>"فارسی", 'dir'=>"rtl", 'charset'=>"UTF-8"),
    'ru' => array('title'=>___("Russian", NULL, "en"), 'translated_title'=>"Русский", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'uz' => array('title'=>___("Uzbek", NULL, "en"), 'translated_title'=>"O‘zbek", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'tk' => array('title'=>___("Turkmen", NULL, "en"), 'translated_title'=>"تركمن / Туркмен", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'cn' => array('title'=>___("Chinese", NULL, "en"), 'translated_title'=>"中文", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'ar' => array('title'=>___("Arabic", NULL, "en"), 'translated_title'=>"العربي", 'dir'=>"rtl", 'charset'=>"UTF-8"),
    'vt' => array('title'=>___("Vietnamese", NULL, "en"), 'translated_title'=>"Tiếng Việt", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'fr' => array('title'=>___("French", NULL, "en"), 'translated_title'=>"Français", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'es' => array('title'=>___("Spanish", NULL, "en"), 'translated_title'=>"Español", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'be' => array('title'=>___("Belarusian", NULL, "en"), 'translated_title'=>"Беларуская", 'dir'=>"ltr", 'charset'=>"UTF-8"),
    'my' => array('title'=>___("Burmese", NULL, "en"), 'translated_title'=>"မြန်မာဘာသာစကား", 'dir'=>"ltr", 'charset'=>"UTF-8"),
);
?>
