<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER['DOCUMENT_ROOT']."/includes/common_includes.php");
include($_SERVER['DOCUMENT_ROOT']."/check_user.php");
include($_SERVER['DOCUMENT_ROOT']."/includes/lang_set.php");

if (!user_has_permission($config, $record_user, "custom_user_agents")) {
    include($_SERVER['DOCUMENT_ROOT']."/http-errors/403.php");
}

// The "fresh" GET parameter ensures that the disable link is always coloured as not-visited.
$fresh = time();

$title = ___("User Agents");

if ($_GET['add'] || $_GET['edit'])
{
   $curs="frm.domain";
}

// new posting
if ($_POST['id']=="add")
{
    $query =
        "INSERT INTO useragent (domain, path, user_agent_string, back_link) ".
        "VALUES (:domain, :path, :user_agent_string, :back_link)";
    
    db_query_execute(
        $config,
        $query,
        convert_null_array(array(
            ":domain" => $_POST['domain'],
            ":path" => $_POST['path'],
            ":user_agent_string" => $_POST['user_agent_string'],
            ":back_link" => $_POST['back_link']
        )));
    
    $last = db_get_last_insert_id($config);
}

$_POST['id'] = (int)$_POST['id'];

// update the record
if (0 != $_POST['id'])
{
    $query =
        "UPDATE useragent SET ".
            "domain = :domain, ".
            "path = :path, ".
            "user_agent_string = :user_agent_string, ".
            "back_link = :back_link ".
        "WHERE id = :id";

    db_query_execute(
        $config,
        $query,
        convert_null_array(array(
            ":domain" => $_POST['domain'],
            ":path" => $_POST['path'],
            ":user_agent_string" => $_POST['user_agent_string'],
            ":back_link" => $_POST['back_link'],
            ":id" => $_POST['id'])));
    
    $last = $_POST['id'];
}

$_GET['rm'] = (int)$_GET['rm'];

// remove the record
if (0 != $_GET['rm'])
{
    $query = "DELETE FROM useragent WHERE id = :id";
    db_query_execute($config, $query, convert_null_array(array(":id" => $_GET['rm'])));
}

include($_SERVER['DOCUMENT_ROOT']."/header.php");

?>

<form name="frm" method="post" action="<?=getenv("SCRIPT_NAME")."?fresh={$fresh}"?>">
    <input name="csrf_token" value="<?=$record_user['csrf_token']?>" type="hidden" />

    <table cellpadding="2" cellspacing="0" border="0">

        <tr>
            <th><?=___("Domain name")?> / <?=___("Path")?></th>
            <th><?=___("User Agent String")?></th>
            <th><a href="<?=getenv("SCRIPT_NAME")?>?fresh=<?=$fresh?>&amp;add=1"><?=___("Add")?></a></th>
        </tr>

<?
if ($_GET['add']) {
?>

        <tr valign="bottom">

            <td colspan="3">
                <?=___("Domain name")?>
                <br>
                <input type="text" name="domain" maxlength="64" size="20" value="<?=escape_html($_POST['domain'])?>" />
                <br>

                <?=___("Path")?>
                <br>
                <input type="text" name="path" maxlength="255" size="60" value="<?=escape_html($_POST['path'])?>" />

                <input type="hidden" name="id" value="add" />

                <br>
                <?=___("User Agent String")?>
                <br>
                <textarea name="user_agent_string" cols="60" rows="5"><?=escape_html($_POST['user_agent_string'])?></textarea>

                <br>
                <?=___("Exit Compatibility Mode link")?>
                <br>
                <textarea name="back_link" cols="60" rows="2"><?=escape_html($_POST['back_link'])?></textarea>
            </td>

            <td>
                <input type="submit" value="<?=___("Add")?>" /> &nbsp; <a href="<?=getenv("SCRIPT_NAME")."?fresh={$fresh}"?>"><?=___("Cancel")?></a>
            </td>
        </tr>

<?
}
$query = "SELECT * FROM useragent ORDER BY id DESC";

$result = db_query_execute($config, $query, convert_null_array(array()));

while ($record = escape_html(db_fetch_result($config, $result)))
{
    $_p="";
    $_s="";

    if ($record['id']==$last) { $_p="{$_p}<b>"; $_s="</b>{$_s}"; }
    if ($record['hidden'])    { $_p="{$_p}<s>"; $_s="</s>{$_s}"; }

    echo "<tr valign=\"bottom\">\n";

    if ($_GET['edit'] != $record['id']) {
        echo "<td>{$_p}{$record['domain']}{$record['path']}{$_s}</td>\n";
        echo "<td>{$_p}" . nl2br($record['user_agent_string']) . "{$_s}</td>\n";

        echo "<td nowrap>";
        echo "{$_p}&nbsp;";
        echo "<a href=\"".getenv("SCRIPT_NAME")."?edit={$record['id']}&amp;fresh={$fresh}\">".___("Edit")."</a> &nbsp; ";
        echo "<a href=\"".getenv("SCRIPT_NAME")."?rm={$record['id']}&amp;fresh={$fresh}\" onClick=\"return(confirm('".str_replace(array("\"", "'", "\\"), "", (___("Delete")))."?'))\">X</a>";
        echo "{$_s}</td>\n";
    } else {
        echo "<td colspan=\"3\">\n<input type=\"hidden\" name=\"id\" value=\"{$record['id']}\" />\n";
        echo ___("Domain name")."\n<br>\n<input type=\"text\" name=\"domain\" maxlength=\"64\" size=\"20\" value=\"".$record['domain']."\" />\n<br>\n";
        echo ___("Path")."\n<br>\n<input type=\"text\" name=\"path\" maxlength=\"255\" size=\"60\" value=\"".$record['path']."\" />\n<br>\n";
        echo ___("User Agent String")."\n<br>\n<textarea name=\"user_agent_string\" cols=\"60\" rows=\"5\">\n".$record['user_agent_string']."</textarea>\n<br>\n";
        echo ___("Exit Compatibility Mode link")."\n<br>\n<textarea name=\"back_link\" cols=\"60\" rows=\"2\">\n".$record['back_link']."</textarea>\n</td>\n";

        echo "<td>{$_p}<input type=\"submit\" value=\"".___("Save")."\" /> &nbsp; <a href=\"".getenv("SCRIPT_NAME")."?fresh={$fresh}\">".___("Cancel")."</a>{$_s}</td>\n";
    }
    echo "</tr>\n\n";
}
?>

    </table>

</form>

<?

db_free_result($result);

include($_SERVER['DOCUMENT_ROOT']."/footer.php");
?>
