<?php
/*
    Psiphon Circumvention Platform
    Copyright (C) 2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");

// check whether user can delete his own account
$user_can_delete =  user_has_permission($config, $record_user, 'delete_account');

if ( ! $user_can_delete )
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
}

$user_deleted = false;


if ($_POST['submit_btn'])
{
    if ( ! $_POST['delete'] )
    {
        header('Location: /profile.php', true, 302);
        die;
    }

    // Delete user and related data
    $res = delete_user_and_related_data($config, ' FROM user WHERE id = :userid', array(':userid' => $record_user['id']));

    // Redirect back to proxy
    $query = "SELECT * FROM proxy WHERE hostname = :hostname";
    $result = db_query_execute($config, $query, convert_null_array(array(":hostname" => $_SERVER[HTTP_HOST])));
    $proxy_record = db_fetch_result($config, $result);

    header("Location: ".$config["ret"].$proxy_record['login_url'], true, 302);
    exit;
}


include($_SERVER[DOCUMENT_ROOT]."/header.php");

?>
    <h3><?php echo ___("Delete account"); ?></h3>

    <div>
        <?php echo ___("Are you sure that you want to completely delete your account? This action cannot be undone."); ?>
    </div>
    <form action="<?=getenv("SCRIPT_NAME")?>" method="post">
        <label for="delete"><?php echo ___("yes"); ?></label>
        <input type="radio" id="delete" name="delete" value="1" />

        <label for="dont_delete"><?php echo ___("no"); ?></label>
        <input type="radio" id="dont_delete" name="delete" value="0" checked="checked" /><br />

        <input name="submit_btn" type="submit" value="<?php echo ___("Submit"); ?>" />
        <input name="csrf_token" value="<?=$record_user['csrf_token']?>" type="hidden" />
    </form>

<? include($_SERVER[DOCUMENT_ROOT]."/footer.php"); ?>
