<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");

// Get login_url for this proxy for use in logout link
// This code is adapted from chk.php

$query = "SELECT * FROM proxy WHERE hostname = :hostname";
$proxy_query_result = db_query_execute($config, $query, convert_null_array(array(":hostname" => $_SERVER[HTTP_HOST])));
$proxy_record = db_fetch_result($config, $proxy_query_result);
db_free_result($proxy_query_result);

if (!$proxy_record)
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/404.php");
}

$login_url = $proxy_record['login_url'];

// NOTE: $header_link_prefix should be set if this file is being included from
// a subdirectory. Also, it must include the trailing slash. For example: "../"

header("Content-type: text/html; charset=".charset());
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title><?=clean_meta($title)?></title>
<?=echo_css()?>
<link rel="shortcut icon" href="<?=$header_link_prefix?>favicon.ico" type="image/x-icon">
</head>

<body style="direction: <?=direction()?>">
<table border="0" cellspacing="0" cellpadding="3" width="100%" class="">

<tr valign="top" class="nowrap">

<td width="5%" rowspan="2" style="border-bottom: solid black 1px; border-left: solid black 1px; border-top: solid black 1px;" class="menu">


<a href="<?=make_proxied_url("")?>"><?=___("Browse")?></a>
<br>
<hr>
<?
$hr = 0;
if (user_has_permission($config, $record_user, "profile")) {
    echo "<a href=\"{$header_link_prefix}profile.php\">".___("Profile")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "invite")) {
    echo "<a href=\"{$header_link_prefix}invite.php\">".___("Create invitations")."</a>\n<br>\n";
    echo "<a href=\"{$header_link_prefix}invite-m.php\">".___("Send invitations")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "bookmarks")) {
    echo "<a href=\"{$header_link_prefix}bookmarks.php\">".___("Bookmarks")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "send_ticket")) {
    echo "<a href=\"{$header_link_prefix}tickets.php\">".___("Support")."</a>\n<br>\n";
    $hr = 1;
}
if ($hr) {
    echo "<hr>\n";
    $hr = 0;
}
if (user_has_permission($config, $record_user, "accounts")) {
    echo "<a href=\"{$header_link_prefix}users.php\">".___("Users")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "proxies")) {
    echo "<a href=\"{$header_link_prefix}proxies.php\">".___("Proxies")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "anonymous")) {
    echo "<a href=\"{$header_link_prefix}anonymous.php\">".___("Guest Browsing")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "reports")) {
    echo "<a href=\"{$header_link_prefix}reports.php\">".___("Reports")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "jsf")) {
    echo "<a href=\"{$header_link_prefix}jsf.php\">".___("JS filter")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "custom_user_agents")) {
    echo "<a href=\"{$header_link_prefix}custom_user_agent.php\">".___("User Agents")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "can_inject_js")) {
    echo "<a href=\"{$header_link_prefix}js-injection/list.php\">".___("JS injections")."</a>\n<br>\n";
    $hr = 1;
}
if (user_has_permission($config, $record_user, "view_propagator_info")) {
    echo "<a href=\"{$header_link_prefix}propagator-info.php\">".___("Propagation")."</a>\n<br>\n";
    echo "<a href=\"{$header_link_prefix}propagator-proxies.php\">".___("Proxies")."</a>\n<br>\n";
    echo "<hr>\n";
}
@include($_SERVER[DOCUMENT_ROOT]."/admin/admin_menu_items.php");
if ($hr) {
    echo "<hr>\n";
    $hr = 0;
}

if (user_has_permission($config, $record_user, "logout")) {
    echo "<a href=\"/logout.php?lu={$login_url}\">".___("Logout")."</a>\n<br>\n";
}

echo '<span id="user_group">', get_user_class_name($record_user['grp']), ': ', '<b>', $record_user['uname'], '</b></span><br />';

?>

</td>

<td style="height: 3px; border-left: none; border-top: solid black 1px; border-right: solid black 1px; border-bottom: solid black 1px;" class="menu"><span class="header1"><?=$title?></span></td>

</tr>

<tr>
<td valign="top" style="height: 300px; border-bottom: none; border-left: solid black 1px;">

<?php
echo_processing_results_and_errors();
?>
