<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

function secure_rand($len = 16)
{
    // If we don't get the random bits we want, abort the whole script
    // (/dev/urandom should always work...?)

    $fp = @fopen('/dev/urandom','rb');
    if (!$fp)
    {
        syslog(LOG_DEBUG, "can't open /dev/urandom");
        exit(0);
    }
    $bits = @fread($fp, $len);
    //if (mb_strlen($bits,'8bit') != $len)
    // should use mb_strlen, but it's not available on the test server...
    if (strlen($bits) != $len)
    {
        syslog(LOG_DEBUG, "can't read /dev/urandom");
        exit(0);
    }
    @fclose($fp);
 
    return $bits;
}


?>
