<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009-2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



/////////////////////////////////////////////////////////////////////////
// here are blue bar messages, have to be in unicode
//include($_SERVER[DOCUMENT_ROOT]."/includes/lang_bb.php");

function charset($lang = Null) {
global $config;
global $record_user;
if ($lang) return $config["lang"][$lang]["charset"];
if (!$record_user["last_lang"]) $record_user["last_lang"]="en";
return $config["lang"][$record_user["last_lang"]]["charset"];
}

function direction() {
global $config;
global $record_user;
if (!$record_user["last_lang"]) $record_user["last_lang"]="en";
return $config["lang"][$record_user["last_lang"]]["dir"];
}

// Translate a message into the correct language.
// lang is optional. If it is not supplied, the current user's last_lang will be
// used (or "en" if that doesn't exist).
$domain = "messages"; //What you named your .po files
bindtextdomain($domain,$_SERVER[DOCUMENT_ROOT]."/locale"); //Where you put the locale dir.
bind_textdomain_codeset("messages", 'UTF-8'); //This was needed in FreeBSD
textdomain($domain);

/// Implement gettext context
if (!function_exists('pgettext')) {
    function pgettext($context, $msgid) {
        $contextString = "{$context}\004{$msgid}";
        $translation = _($contextString);
        if ($translation == $contextString)  return $msgid;
        else  return $translation;
    }

    function npgettext($context, $msgid, $msgid_plural, $num) {
        $contextString = "{$context}\004{$msgid}";
        $contextStringp = "{$context}\004{$msgid_plural}";
        $translation = ngettext($contextString, $contextStringp, $num);
        if ($translation == $contextString ||
                $translation == $contextStringp)  return $msgid;
        else  return $translation;
    }
}

// New gettext keyword for regular strings with optional context and lang arguments
function ___($message, $context = NULL, $lang = NULL) 
{
    global $record_user;
    // If lang wasn't supplied, use the current user's last_lang.
    if (!$lang)
    {
        $lang = $record_user["last_lang"] ? $record_user["last_lang"] : "en";
    }
    if(PHP_OS == "FreeBSD")
    {
        putenv("LANG=$lang"); //This works in FreeBSD??
    }
    else
    {
        putenv("LANGUAGE=$lang"); //This works in Ubuntu??
    }
    setlocale(LC_MESSAGES,'');

    if(!$context ) 
    {
        return gettext($message);
    }
    return pgettext($context, $message);
}   

// New gettext keyword for plural strings with optional context and lang arguments
function n___($message, $message_plural, $num, $context = NULL, $lang = NULL) {
    global $record_user;
    // If lang wasn't supplied, use the current user's last_lang.
    if (!$lang)
    {
        $lang = $record_user["last_lang"] ? $record_user["last_lang"] : "en";
    }
    if(PHP_OS == "FreeBSD")
    {
        putenv("LANG=$lang"); //This works in FreeBSD??
    }
    else
    {
        putenv("LANGUAGE=$lang"); //This works in Ubuntu??
    }
    setlocale(LC_MESSAGES,'');
    if(!$context ) 
    {
        return ngettext($message, $message_plural, $num);
    }
    return npgettext($context, $message, $message_plural, $num);
}
?>
