<?php
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* 
 * lang_set.php
 *
 * Include at the top of all page files so that the current language is set before
 * any translation calls (msg) are made.
 * NOTE: Must be included *after* config.php and check_user.php.
 */

if (!$config)
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/503.php");
}

if (isset($_POST["lang"]) && array_key_exists($_POST["lang"], $config["lang"]))
{
    $head_query = "UPDATE user SET last_lang = :last_lang WHERE id = :user_id";
    db_query_execute($config, $head_query, convert_null_array(array(":last_lang" => $_POST['lang'], ":user_id" => $record_user['id'])));

    $record_user["last_lang"] = $_POST["lang"];
}

?>
