<?php
/*
    Psiphon Circumvention Platform
    Copyright (C) 2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//
// js-injection/data.php
//
// This script  builds JSON string to populate the datatable of js_injections
//
include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");
function escape_double_quotes($str)
{
    return str_replace('"', '\"', $str);
}
$query_sql_params = array();
/* Paging */
if ( isset( $_GET['iDisplayStart'] ) && isset($_GET['iDisplayLength']))
{
    $query_limit_sql =  "LIMIT ";
    $query_limit_sql .= cast_str_to_int($_GET['iDisplayStart']) ;
    $query_limit_sql .=  ", ";
    $query_limit_sql .= cast_str_to_int($_GET['iDisplayLength']) ;
}

/* Ordering */
if ( isset( $_GET['iSortCol_0'] ) )
{
    $query_sort_sql = "ORDER BY ";
    for ( $i=0 ; $i<cast_str_to_int( $_GET['iSortingCols'] ) ; $i++ )
    {
        $query_sort_sql .= fnColumnToField(( $_GET['iSortCol_'.$i] ))." ".( $_GET['sSortDir_'.$i] ) ;
        $query_sort_sql .= ", ";
    }
    $query_sort_sql = substr_replace( $query_sort_sql, "", -2 );
}

/* Filtering */
if ( $_GET['sSearch'] != "" )
{
    $query_where_sql = "WHERE description LIKE :search_string OR notes LIKE :search_string";
    $query_sql_params[':search_string'] =  "%" . $_GET['sSearch'] . "%";
}

$query = "
SELECT SQL_CALC_FOUND_ROWS id, description, valid_from, valid_to, notes
FROM   js_injection {$query_where_sql} {$query_sort_sql} {$query_limit_sql}";


$rResult = db_query_execute($config, $query, convert_null_array($query_sql_params));


$query = " SELECT FOUND_ROWS()  as found_rows";
$rResultFilterTotal = db_query_execute($config, $query, convert_null_array(array()));
while ($record = db_fetch_result($config, $rResultFilterTotal))
{
    $iFilteredTotal = $record['found_rows'];
}

$query = " SELECT COUNT(id)  as total FROM   js_injection ";
$rResultTotal = db_query_execute($config, $query, convert_null_array(array()));
while ($record = db_fetch_result($config, $rResultTotal))
{
    $iTotal = $record['total'];
}

$sOutput = '{';
$sOutput .= '"sEcho": '.intval($_GET['sEcho']).', ';
$sOutput .= '"iTotalRecords": '.$iTotal.', ';
$sOutput .= '"iTotalDisplayRecords": '.$iFilteredTotal.', ';
$sOutput .= '"aaData": [ ';
while ($record = db_fetch_result($config, $rResult))
{
    $sOutput .= "[";
    $sOutput .= '"<a href=\"/js-injection/edit.php?js_injection_id='.$record['id'].'\">'.escape_double_quotes($record['description']).'</a>",';
    $sOutput .= '"'.(date("M j, Y", $record['valid_from'])).'",';
    $sOutput .= '"'.(date("M j, Y", $record['valid_to'])).'",';
    $sOutput .= '"'.escape_double_quotes($record['notes']).'",';
    $sOutput .= '"<a href=\"#\" class=\"delX\" deleteid=\"'.$record['id'].'\">X</a>"';
    $sOutput .= "],";
}
$sOutput = substr_replace( $sOutput, "", -1 );
$sOutput .= '] }';

echo $sOutput;


function fnColumnToField( $i )
{
    switch($i)
    {
        case 0:
            return "description";
        case 1:
            return "valid_from";
        case 2:
            return "valid_to";
        case 3:
            return "notes";
    }
    return "id";
}
?>
