<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//
// js-injection/injection.php
//
// This script is included from bluebar and does the actual js injection.


// Get injection code for this proxy checking if user opted out of seeing
// this js injection already 
$query = "SELECT injection_code, id FROM js_injection WHERE ".
"id IN (SELECT js_injection_id FROM js_injection_proxy WHERE proxy_id = :proxy_id) ".
"AND id NOT IN (SELECT js_injection_id FROM js_injection_user_optout WHERE user_id = :user_id) ".
"AND id NOT IN (SELECT js_injection_id FROM js_injection_session_optout WHERE psiphon_session = :psiphon_session) ".
"AND valid_from < UNIX_TIMESTAMP() AND valid_to > UNIX_TIMESTAMP() ".
"ORDER BY RAND() LIMIT 1"; 

$query_sql_params = array(
        "proxy_id"=>$record_user["current_proxy"], 
        "user_id"=>$record_user["id"], 
        ":psiphon_session"=>$record_user["session"]
        );

$result = db_query_execute($config, $query, convert_null_array($query_sql_params));
$record = db_fetch_result($config, $result);

//Inject code
// Apart from injecting js from the DB we also write js_injection_id to the page 
// so users can opt out. We cannot effectively get this data from backend
// because js_injection is not unique per proxy, i.e. we do not know what js_injection 
// is currently shown
//
if($record)
{
    print("<script type=\"text/javascript\">\n");
    print "var js_injection_id =" . $record["id"].";\n"; 
    print($record["injection_code"]);
    print("\n</script>\n");
}
?>
