<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//
// js-injection/list.php
//
// This screen is used to list all existing js injections
//

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");

//
// Business logic
//

// Check user has permission to access this screen

if (!user_has_permission($config, $record_user, "can_inject_js"))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
    // 403.php exits
}
    
// Screen title. Must come before the header.php include.

$title = ___("JS injections");
$header_link_prefix = "/";
include($_SERVER[DOCUMENT_ROOT]."/header.php");
?>
<style type="text/css" title="currentStyle">
@import "/js-injection/datatables.css";
</style>
<script type="text/javascript" language="javascript" src="/js-injection/jquery.js"></script>
<script type="text/javascript" language="javascript" src="/js-injection/jquery.dataTables.js.php"></script>

<script type="text/javascript" charset="utf-8">
$(document).ready(function() {
        oTable = $('#injections').dataTable( {
            "bProcessing": true,
            "bServerSide": true,
            "bStateSave": true,
            "sPaginationType": "full_numbers",
            "sAjaxSource": "/js-injection/data.php",
            "aoColumns": [
            { "bSortable": true },
            { "bSortable": true },
            { "bSortable": true },
            { "bSortable": true },
            { "bSortable": false }]
            } );
        $(".delX").live('click', function(event) {
            $(oTable.fnSettings().aoData).each(function (){
                $(this.nTr).removeClass('row_selected');
                });
            $(event.target.parentNode.parentNode).addClass('row_selected');
            if(confirm('<?=___("Delete selected entry?")?>'))
            {
                var deleteid = $(event.target).attr('deleteid');
                $.post("delete.php", { js_injection_id: deleteid, csrf_token : "<?=$record_user["csrf_token"]?>" }, function(data)
                {
                    if(typeof(data.status)!="indefined" && data.status == 'deleted')
                    {
                        var anSelected = fnGetSelected( oTable );
                        oTable.fnDeleteRow( anSelected[0] );
                    }
                },
                "json"
                );
            }
            else
            {
                $(event.target.parentNode.parentNode).removeClass('row_selected');
            }
        });


} );
function fnGetSelected( oTableLocal )
{
    var aReturn = new Array();
    var aTrs = oTableLocal.fnGetNodes();

    for ( var i=0 ; i<aTrs.length ; i++ )
    {
        if ( $(aTrs[i]).hasClass('row_selected') )
        {
            aReturn.push( aTrs[i] );
        }
    }
    return aReturn;
}
</script>
<table cellpadding="0" cellspacing="0" border="0"  id="injections" class="display">
	<thead>

		<tr>
			<th width="20%"><?=___("Description")?></th>
			<th width="15%"><?=___("Valid from")?></th>
			<th width="15%"><?=___("Valid to")?></th>
			<th width="45%"><?=___("Notes")?></th>
			<th width="5%"><a href="/js-injection/edit.php"><?=___("Add")?></a></th>

		</tr>
	</thead>
	<tbody>
		<tr>
			<td colspan="4" class="dataTables_empty"></td>
		</tr>
	</tbody>
	<tfoot>

	</tfoot>
</table>

<?
include($_SERVER[DOCUMENT_ROOT]."/footer.php");
