<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//
// js-injection/useraction.php
//
// This script opts out users of seeing js_injections and optionally 
// redirects them to a provided in $_GET[redirect] http(s) only URL
// Accepted parameters for 'optout' are 'forgood' and 'session'
// ie ?optout=forgood&redirect=http://psiphon.ca
// Note that 'forgood' value of 'optout' will be treated as 'session' 
// for anonymous users 

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");

$js_injection_id = cast_str_to_int($_GET["js_injection_id"]);
if($js_injection_id <= 0)
{
    //do nothing
    exit(0);
}

if($_GET["optout"] == "forgood" || $_GET["optout"] == "session")
{
    if(is_anonymous_user($user_record))
    {
        //in case of anonymous user
        //break out and use 'per session' opt out logic
        $_GET["optout"] = "session";
    }
    //Check if user passes legit js_injection_id 
    $query = "SELECT injection_code, id FROM js_injection WHERE ".
        "id IN (SELECT js_injection_id FROM js_injection_proxy WHERE proxy_id = :proxy_id) AND ".
        "id = :js_injection_id AND ".
        "valid_from < UNIX_TIMESTAMP() AND valid_to > UNIX_TIMESTAMP() ";
    $query_sql_params = array(":proxy_id"=>$record_user["current_proxy"], ":js_injection_id"=>$js_injection_id);

    $result = db_query_execute($config, $query, convert_null_array($query_sql_params));
    $record = db_fetch_result($config, $result);

    if($record)
    {
        if($_GET["optout"] == "forgood")
        {
            $query = "INSERT IGNORE INTO js_injection_user_optout(user_id, js_injection_id, created) " .
                "values(:user_id, :js_injection_id, UNIX_TIMESTAMP())";
            $query_sql_params = array(":user_id"=>$record_user["id"], ":js_injection_id"=>$js_injection_id);
        }
        else
        {
            $query = "INSERT IGNORE INTO js_injection_session_optout(psiphon_session, js_injection_id, created) " .
                "values(:psiphon_session, :js_injection_id, UNIX_TIMESTAMP())";
            $query_sql_params = array(":psiphon_session"=>$record_user["session"], ":js_injection_id"=>$js_injection_id);
        }
        db_query_execute($config, $query, convert_null_array($query_sql_params));
    }
}

if($_GET["optout"] == "session")
{
    // We are not going to check if js_injection_id is legit 
    // in this case as there's no db transactions involved 

    $optout_js_injections = array();
    
    if($optout_cookie = $_COOKIE["s"])
    { //sanitize the input
        $optout_js_injections = explode(":", $optout_cookie);
        foreach($optout_js_injections as $key=> $val)
        {
            $casted = cast_str_to_int($val);
            if(!$casted || $casted < 0)
                unset($optout_js_injections[$key]);
        }
    }
    
    if(empty($optout_js_injections)) //Brand new one
    {
        $optout_cookie = $js_injection_id;
    }
    else if(in_array($js_injection_id, $optout_js_injections)) //Already present in the existing array(shouldn't happen)
    {
        $optout_cookie = implode(":", $optout_js_injections);
    }
    else //Add to the end
    {
        $optout_cookie = implode(":", $optout_js_injections) . ":" . $js_injection_id;
    }
    header("Set-Cookie: s={$optout_cookie}; path=/", true);
}

//http(s) only redirects
if(strpos($_GET["redirect"], "http://") === 0 || strpos($_GET["redirect"], "https://") === 0)
{

    $redirect = urlencode($_GET["redirect"]);
    $csrf_token = $record_user["csrf_token"];
    header("Location: /redirect.php"."?csrf_token=".$csrf_token ."&url=".$redirect , true, 302);
    exit(0);
}
?>
