/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

fixedMenuId = 'psibluebar';
pageCounterId = 'psipagecounter';
formID = 'psiform';

var fixedMenu = 
{
    hasInner: typeof(window.innerWidth) == 'number',
    hasElement: document.documentElement != null
            && document.documentElement.clientWidth,

    menu: document.getElementById
                    ? document.getElementById(fixedMenuId)
    : document.all
                    ? document.all[fixedMenuId]
    : document.layers[fixedMenuId],
    
    pageviewcounter: document.getElementById
                    ? document.getElementById(pageCounterId)
    : document.all
                    ? document.all[pageCounterId]
    : document.layers[pageCounterId],
    
    form: document.getElementById
                    ? document.getElementById(formID)
    : document.all
                    ? document.all[formID]
    : document.layers[formID]
    
};

fixedMenu.computeShifts = function()
{
    fixedMenu.shiftX = fixedMenu.hasInner
            ? pageXOffset
    : fixedMenu.hasElement
            ? document.documentElement.scrollLeft
    : document.body.scrollLeft;
    if (fixedMenu.targetLeft > 0)
    fixedMenu.shiftX += fixedMenu.targetLeft;
    else
    {
        fixedMenu.shiftX +=
                (fixedMenu.hasElement
                ? document.documentElement.clientWidth
            : fixedMenu.hasInner
                ? window.innerWidth - 20
            : document.body.clientWidth)
                - fixedMenu.targetRight
                - fixedMenu.menu.offsetWidth;
    }

    fixedMenu.shiftY = fixedMenu.hasInner
            ? pageYOffset
    : fixedMenu.hasElement
            ? document.documentElement.scrollTop
    : document.body.scrollTop;
    
		if (fixedMenu.targetTop > 0)
    fixedMenu.shiftY += fixedMenu.targetTop;
    else
    {
        fixedMenu.shiftY +=
                (fixedMenu.hasElement
                ? document.documentElement.clientHeight
            : fixedMenu.hasInner
                ? window.innerHeight - 20
            : document.body.clientHeight)
                - fixedMenu.targetBottom
                - fixedMenu.menu.offsetHeight;
    }
		var y=parseInt(fixedMenu.shiftY);
		if (isNaN(y)) fixedMenu.shiftY = 0;
};

fixedMenu.moveMenu = function()
{
    fixedMenu.computeShifts();

    if (fixedMenu.currentX != fixedMenu.shiftX
    || fixedMenu.currentY != fixedMenu.shiftY)
    {
        fixedMenu.currentX = fixedMenu.shiftX;
        fixedMenu.currentY = fixedMenu.shiftY;

        if (document.layers)
        {
//            fixedMenu.menu.left = fixedMenu.currentX;
            fixedMenu.menu.top = fixedMenu.currentY;
        }
        else
        {
//            fixedMenu.menu.style.left = fixedMenu.currentX + 'px';
            fixedMenu.menu.style.top = fixedMenu.currentY + 'px';
        }
    }

//    fixedMenu.menu.style.right = '';
    fixedMenu.menu.style.bottom = '';
};

fixedMenu.floatMenu = function()
{
    fixedMenu.moveMenu();
    setTimeout('fixedMenu.floatMenu()', 20);
};

// addEvent designed by Aaron Moore
fixedMenu.addEvent = function(element, listener, handler)
{
    if(typeof element[listener] != 'function' ||
    typeof element[listener + '_num'] == 'undefined')
    {
        element[listener + '_num'] = 0;
        if (typeof element[listener] == 'function')
        {
            element[listener + 0] = element[listener];
            element[listener + '_num']++;
        }
        element[listener] = function(e)
        {
            var r = true;
            e = (e) ? e : window.event;
            for(var i = 0; i < element[listener + '_num']; i++)
            if(element[listener + i](e) === false)
            r = false;
            return r;
        }
    }

    //if handler is not already stored, assign it
    for(var i = 0; i < element[listener + '_num']; i++)
    if(element[listener + i] == handler)
    return;
    element[listener + element[listener + '_num']] = handler;
    element[listener + '_num']++;
};

fixedMenu.supportsFixed = function()
{
    var testDiv = document.createElement("div");
    testDiv.id = "testingPositionFixed";
    testDiv.style.position = "fixed";
    testDiv.style.top = "0px";
    testDiv.style.right = "0px";
    document.body.appendChild(testDiv);
    var offset = 1;
    if (typeof testDiv.offsetTop == "number"
    && testDiv.offsetTop != null
    && testDiv.offsetTop != "undefined")
    {
        offset = parseInt(testDiv.offsetTop);
    }
    if (offset == 0)
    {
        return true;
    }

    return false;
};

fixedMenu.initPageViewCounter = function()
{
    var urlId = 'psiphon_url_display';
    var sURL = '';
    if (document.getElementById)
    {
        sURL = document.getElementById(urlId).value;
    }
    else if (document.all)
    {
        sURL = document.all[urlId].value;
    }
    else if (document.layers)
    {
        sURL = document.layers[urlId].value;
    }

    if(sURL.length == 0)
    {
        return;
    }
    fixedMenu.pageviewcounter.innerHTML = '<img src="/pageview_counter.php?u='+sURL+'" style="border:0; width:0; height:0;"></img>';
};

fixedMenu.init = function()
{
    if (top != self) {
        fixedMenu.menu.style.display='none';
        return;
    }
    else
    {
        fixedMenu.initPageViewCounter();
    }
    if (fixedMenu.supportsFixed())
    fixedMenu.menu.style.position = "fixed";
    else
    {
        var ob =
                document.layers
                ? fixedMenu.menu
            : fixedMenu.menu.style;

//        fixedMenu.targetLeft = parseInt(ob.left);
        fixedMenu.targetTop = parseInt(ob.top);
//        fixedMenu.targetRight = parseInt(ob.right);
        fixedMenu.targetBottom = parseInt(ob.bottom);

        if (document.layers)
        {
            menu.left = 0;
            menu.top = 0;
        }
        fixedMenu.addEvent(window, 'onscroll', fixedMenu.moveMenu);
        fixedMenu.floatMenu();
    }
};


function move_up()
{
    if (fixedMenu.menu.style.position=='fixed')
    {
        fixedMenu.menu.style.top='0px';
        fixedMenu.menu.style.bottom='';
    }
    else
    {
        fixedMenu.targetTop=0;
        fixedMenu.targetBottom=NaN;
    }
    document.cookie="verticalpos=up; path=/";
}

function move_down()
{
    if (fixedMenu.menu.style.position=='fixed')
    {
        fixedMenu.menu.style.bottom='0px';
        fixedMenu.menu.style.top='';
    }
    else
    {
        fixedMenu.targetBottom=0;
        fixedMenu.targetTop=NaN;
    }
    document.cookie="verticalpos=down; path=/";

}

function get_cookie(Name) {
    var search = Name + "="
            var returnvalue = "";
    if (document.cookie.length > 0) {
        offset = document.cookie.indexOf(search)
        if (offset != -1) { // if cookie exists
            offset += search.length
      // set index of beginning of value
                    end = document.cookie.indexOf(";", offset);
      // set index of end of cookie value
            if (end == -1)
            end = document.cookie.length;
            returnvalue=unescape(document.cookie.substring(offset, end))
        }
    }
    return returnvalue;
}

function trim_str(str) {
    str = str.replace( /^\s+/g, "" );
    return str.replace( /\s+$/g, "" );
}



fixedMenu.init();
if (get_cookie("verticalpos") == 'down')
    move_down();

