<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");

if (!user_has_permission($config, $record_user, "jsf")) {
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
}

$y = time();

if ($_GET[add] || $_GET[edit])
   $curs="frm.addr";

$title = ___("JS filter");

if ($_GET[add] || $_GET[edit])
   $curs="frm.domain";


// new posting
if ($_POST[id]=="add")
{
    $flags = (int)$_POST["f_case"] | (int)$_POST["f_last"];

    $query =
        "INSERT INTO jsf (ord, domain, path, srch, repl, flags) ".
         "VALUES (UNIX_TIMESTAMP(), :domain, :path, :srch, :repl, :flags)";
    
    db_query_execute(
        $config,
        $query,
        convert_null_array(array(
            ":domain" => $_POST['domain'],
            ":path" => $_POST['path'],
            ":srch" => $_POST['srch'],
            ":repl" => $_POST['repl'],
            ":flags" => $flags)));
    
    $last = db_get_last_insert_id($config);
}

// update the record
if ($_POST[id]=(int)$_POST[id])
{
    $flags = (int)$_POST["f_case"] | (int)$_POST["f_last"];

    $query =
        "UPDATE jsf SET ".
            "domain = :domain, ".
            "path = :path, ".
            "srch = :srch, ".
            "repl = :repl, ".
            "flags = :flags ".
         "WHERE id = :id";

    db_query_execute(
        $config,
        $query,
        convert_null_array(array(
            ":domain" => $_POST['domain'],
            ":path" => $_POST['path'],
            ":srch" => $_POST['srch'],
            ":repl" => $_POST['repl'],
            ":flags" => $flags,
            ":id" => $_POST['id'])));
    
    $last = $_POST['id'];
}

// change order
if ($_GET[up]=(int)$_GET[up])
{
    $query = "SELECT id, ord FROM jsf ORDER BY ord";

    if ($_GET[up]<0)
    {
        $_GET[up]=-$_GET[up];
    }
    else
    {
        $query .= " DESC";
    }
               
    $result = db_query_execute($config, $query, convert_null_array(array()));

    while ($record = db_fetch_result($config, $result))
    {
        if ($record[id]==$_GET[up])
        {
            $curr_id=$record[id];
            $curr_ord=$record[ord];
            break;
        }

        $prev_id=$record[id];
        $prev_ord=$record[ord];
    }

    db_free_result($result);

    if ($prev_id && $prev_ord && $curr_id && $curr_ord)
    {
        $query = "UPDATE jsf SET ord = :ord WHERE id = :id";
        db_query_execute($config, $query, convert_null_array(array(":ord" => $curr_ord, ":id" => $prev_id)));

        $query = "UPDATE jsf SET ord = :ord WHERE id = :id";
        db_query_execute($config, $query, convert_null_array(array(":ord" => $prev_ord, ":id" => $curr_id)));
    }
    
    $last = $_GET[up];
}


if ($_GET["rm"]=(int)$_GET["rm"])
{
    $query = "DELETE FROM jsf WHERE id = :id";
    db_query_execute($config, $query, convert_null_array(array(":id" => $_GET['rm'])));
}


include($_SERVER[DOCUMENT_ROOT]."/header.php");

?>

<form name="frm" method="post" action="<?=getenv("SCRIPT_NAME")."?y={$y}"?>">
<input name="csrf_token" value="<?=$record_user['csrf_token']?>" type="hidden">

<table cellpadding="2" cellspacing="0" border="0">

<tr>
<th><?=___("Domain name")?> / <?=___("Path")?></th>
<th><?=___("Search")?></th>
<th><?=___("Replace")?></th>
<th><?=___("Case insensitive")?></th>
<th><?=___("Last rule")?></th>
<th><a href="<?=getenv("SCRIPT_NAME")?>?y=<?=$y?>&amp;add=1"><?=___("Add")?></a></th>
</tr>

<?
if ($_GET["add"]) {
?>

<tr valign="bottom">

<td colspan="3">
<?=___("Domain name")?>
<br>
<input type="text" name="domain" maxlength="64" size="20" value="<?=htmlentities($_POST["domain"], ENT_QUOTES, charset())?>">
<br>

<?=___("Path")?>
<br>
<input type="text" name="path" maxlength="255" size="60" value="<?=htmlentities($_POST["path"], ENT_QUOTES, charset())?>">

<input type="hidden" name="id" value="add">

<br>
<?=___("Search")?>
<br>
<textarea name="srch" cols="60" rows="5">
<?=htmlentities($_POST["srch"], ENT_QUOTES, charset())?></textarea>

<br>
<?=___("Replace")?>
<br>
<textarea name="repl" cols="60" rows="10">
<?=htmlentities($_POST["repl"], ENT_QUOTES, charset())?></textarea>
</td>

<td><input type="checkbox" name="f_case" value="1"<?=$_POST["f_case"]?" checked":""?>></td>
<td><input type="checkbox" name="f_last" value="128"<?=$_POST["f_last"]?" checked":""?>></td>

<td><input type="submit" value="<?=___("Add")?>"> &nbsp; <a href="<?=getenv("SCRIPT_NAME")."?y={$y}"?>"><?=___("Cancel")?></a></td>
</tr>

<?
}
$query = "SELECT * FROM jsf ORDER BY ord DESC";

$result = db_query_execute($config, $query, convert_null_array(array()));

while ($record = db_fetch_result($config, $result))
{
    $_p="";
    $_s="";

    if ($record[id]==$last) { $_p="{$_p}<b>"; $_s="</b>{$_s}"; }
    if ($record[hidden])    { $_p="{$_p}<s>"; $_s="</s>{$_s}"; }

    echo "<tr valign=\"bottom\">\n";

    if ($_GET[edit] != $record[id]) {
        echo "<td>{$_p}{$record["domain"]}{$record["path"]}{$_s}</td>\n";
        echo "<td>{$_p}" . nl2br(htmlentities($record["srch"], ENT_QUOTES, charset())) . "{$_s}</td>\n";
        echo "<td>{$_p}" . nl2br(htmlentities($record["repl"], ENT_QUOTES, charset())) . "{$_s}</td>\n";
        echo "<td>".(($record["flags"] & 1)?___("yes"):___("no"))."</td>\n";
        echo "<td>".(($record["flags"] & 128)?___("yes"):___("no"))."</td>\n";

        echo "<td nowrap>";
        echo "{$_p}&nbsp;";
        echo "<a href=\"".getenv("SCRIPT_NAME")."?edit={$record[id]}&amp;y={$y}\">".___("Edit")."</a> &nbsp; ";
        echo "<a href=\"".getenv("SCRIPT_NAME")."?up={$record[id]}&amp;y={$y}\">/\\</a> &nbsp; ";
        echo "<a href=\"".getenv("SCRIPT_NAME")."?up=-{$record[id]}&amp;y={$y}\">\\/</a> &nbsp; ";
        echo "<a href=\"".getenv("SCRIPT_NAME")."?rm={$record[id]}&amp;y={$y}\" onClick=\"return(confirm('".str_replace(array("\"", "'", "\\"), "", (___("Delete")))."?'))\">X</a>";
        echo "{$_s}</td>\n";
    } else {
        echo "<td colspan=\"3\">\n<input type=\"hidden\" name=\"id\" value=\"{$record[id]}\">\n";
        echo ___("Domain name")."\n<br>\n<input type=\"text\" name=\"domain\" maxlength=\"64\" size=\"20\" value=\"".htmlentities($record["domain"], ENT_QUOTES, charset())."\">\n<br>\n";
        echo ___("Path")."\n<br>\n<input type=\"text\" name=\"path\" maxlength=\"255\" size=\"60\" value=\"".htmlentities($record["path"], ENT_QUOTES, charset())."\">\n<br>\n";

        echo ___("Search")."\n<br>\n<textarea name=\"srch\" cols=\"60\" rows=\"5\">\n".htmlentities($record["srch"], ENT_QUOTES, charset())."</textarea>\n<br>\n";

        echo ___("Replace")."\n<br>\n<textarea name=\"repl\" cols=\"60\" rows=\"5\">\n".htmlentities($record["repl"], ENT_QUOTES, charset())."</textarea>\n</td>\n";

        echo "<td><input type=\"checkbox\" name=\"f_case\" value=\"1\"".(($record["flags"] & 1)?" checked":"")."></td>\n";
        echo "<td><input type=\"checkbox\" name=\"f_last\" value=\"128\"".(($record["flags"] & 128)?" checked":"")."></td>\n";

        echo "<td>{$_p}<input type=\"submit\" value=\"".___("Save")."\"> &nbsp; <a href=\"".getenv("SCRIPT_NAME")."?y={$y}\">".___("Cancel")."</a>{$_s}</td>\n";
    }
    echo "</tr>\n\n";
}
?>

</table>

</form>

<?

db_free_result($result);

include($_SERVER[DOCUMENT_ROOT]."/footer.php");
?>
