<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");

// Check the "lu" parameter matches the encoded login_url for this host; this is
// part of the randomized URL defenses that prevents a scanner from finding anything
// other than 404 unless it provides some known random value.
// This code is adapted from chk.php

$query = "SELECT * FROM proxy WHERE hostname = :hostname";
$result = db_query_execute($config, $query, convert_null_array(array(":hostname" => $_SERVER[HTTP_HOST])));
$proxy_record = db_fetch_result($config, $result);

if (!$proxy_record || $proxy_record['login_url'] != $_GET[lu])
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/404.php");
}

$login_url = $proxy_record['login_url'];

// Don't require user to agree to terms in this case
$dont_require_terms = 1;
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");

// Check user has permission to access this screen

if (!user_has_permission($config, $record_user, "logout"))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
    // 403.php exits
}
// Invalidate the session by setting it to a random value.
$query = "UPDATE user SET session = NULL WHERE id = :id";
db_query_execute($config, $query, convert_null_array(array(":id" => $record_user['id'])));

$query = "DELETE FROM cookie WHERE user = :user";
db_query_execute($config, $query, convert_null_array(array(":user" => $record_user['id'])));

header("Set-Cookie: p=; path=/; expires=Thu, 01-Jan-1970 00:00:00 GMT", false);

$logout_url = $login_url;
header("Location: {$config["ret"]}" . $logout_url);

exit();
?>
