<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009-2010 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//
// propagator-proxies.php
//
// This screen is used by Propagators to view the list of Proxies they're associated with.
//

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");

//
// Business logic
//

// Check user has permission to access this screen

if (!user_has_permission($config, $record_user, "view_propagator_info"))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
    // 403.php exits
}

// Screen title. Must come before the header.php include.

$title = ___("Proxies");

while ($_POST[id]=(int)$_POST[id])
{
    $propagator_notes = trim($_POST['propagator_notes']);

    $query = "UPDATE proxy SET propagator_notes = :propagator_notes WHERE id = :id";
    db_query_execute($config, $query, convert_null_array(array( ":propagator_notes" => $propagator_notes, ":id" => $_POST['id'])));

    break;
}


include($_SERVER[DOCUMENT_ROOT]."/header.php");


?>
<form name="frm" method="post" action="<?=getenv("SCRIPT_NAME")?>">
<input name="csrf_token" value="<?=$record_user['csrf_token']?>" type="hidden">

<table cellpadding="2" cellspacing="0" border="0" class="brd">

<tr>
<th><?=___("Proxy Name")?></th>
<th><?=___("Hostname")?>/<?=___("Proxy IP")?></th>
<th><?=___("Proxy Login URL")?></th>
<th><?=___("Propagator Proxy Notes")?></th>
<th></th>
</tr>

<?
$query =
    "SELECT proxy.*, ".proxy_label_sql("proxy")." AS label ".
    "FROM proxy ".
    "WHERE proxy.id IN (SELECT proxyid FROM userproxy WHERE userid = :current_user_id) ".
    "ORDER BY label";

$query_params = array(':current_user_id' => $record_user['id']);

$result = db_query_execute($config, $query, convert_null_array($query_params));

$_p=$_s="";

while ($record = escape_html(db_fetch_result($config, $result)))
{
    echo "<tr>";

    echo "<td>{$record['name']}</td>\n";
    echo "<td>{$record['hostname']}</td>\n";
    echo "<td>".make_home_url($config, $record[id])."</td>\n";
    if ($_GET[edit]!=$record[id]) {
        if (strlen($record['propagator_notes']) == 0)
        {
            echo "<td>{$_p}".escape_html($record['propagator_notes'])."{$_s}</td>\n";
        }
        else
        {
            $rows = (int)substr_count($record['propagator_notes'], "\n");
            echo "<td>{$_p}<textarea rows=\"".$rows."\" cols=\"60\" wrap=\"off\" style=\"width:98%\" readonly>".escape_html($record['propagator_notes'])."</textarea></td>\n";
        }

        echo "<td><a href=\"".getenv("SCRIPT_NAME")."?edit={$record[id]}\">{$_p}".___("Edit")."{$_s}</a> &nbsp;";
        echo "</td>\n";
    }
      else {
        echo "<td>";
        echo "<textarea name=\"propagator_notes\" rows=\"10\" cols=\"60\" wrap=\"off\" style=\"width:100%\">".escape_html($record['propagator_notes'])."</textarea>";
        echo "</td>\n";
        

        echo "<td>";
        echo "<input type=\"submit\" value=\"".___("Update")."\"> &nbsp; <a href=\"".getenv("SCRIPT_NAME")."\">".___("Cancel")."</a>";
        echo "<input type=\"hidden\" name=\"id\" value=\"{$record["id"]}\">";
        echo "</td>\n";
    }

    echo "</tr>\n";
}
?>

</table>

</form>

<?
include($_SERVER[DOCUMENT_ROOT]."/footer.php");
?>
