<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");

if (!user_has_permission($config, $record_user, "proxies")) {
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
}

$proxy_login_url = "";

if ($_GET[add] || $_GET[edit])
   $curs="frm.name";
    
$title = ___("Proxies");

// new posting
while ($_POST[id]=="add") {
    $hostname = trim($_POST['hostname']);
    if (!$hostname || !is_hostname($hostname))
    {
        $_GET[add] = 1;
        $curs="frm.hostname";
        $processing_errors[] = ___("Wrong IP syntax");
        break;
    }
    
    // Trim leading and trailing whitespace and slashes
    $proxy_login_url = trim($_POST['login_url'], " \t\n\r\0\x0B/");

    // Validate without the leading and trailing slashes
    if(!is_login_url($proxy_login_url))
    {
        $_GET[add] = 1;
        $curs="frm.login_url";
        $processing_errors[] = ___("Login URL contains illegal characters. Allowed characters are 'a-z', '0-9' and '/'");
        break;
    }

    // Make sure that login_url has a slash at the beginning and at the end.
    // This mitigates an issue with firefox where it caches redirects.
    // For example, if a proxy url is /001 (with no trailing slash), when logging
    // out, firefox will redirect to /001/, and a 404 will result.
    $proxy_login_url = "/" . $proxy_login_url . "/";

    $name = trim($_POST['name']);
    $notes = trim($_POST['notes']);

    $http_proxy_port_number = trim($_POST['http_proxy_port_number']);
    $ssh_server_port_number = trim($_POST['ssh_server_port_number']);
    $ssh_server_fingerprint = trim($_POST['ssh_server_fingerprint']);
    $ssh_user_name = trim($_POST['ssh_user_name']);
    $ssh_user_password = trim($_POST['ssh_user_password']);

    // NOTE: Because we don't have transactions, there is a race condition between
    // the address conflict check and the insert/update attempt. If a conflict is
    // introduced between the check and the insert/update, a DB error will occur.
    // This is unfortunate but acceptable (at this time).

    if (db_check_if_value_exists($config, "proxy", "hostname", $hostname))
    {
        $_GET[add] = 1;
        $processing_errors[] = ___("Address already exists");
        $curs="frm.hostname";
        break;
    }

    $query = "INSERT INTO proxy ".
             "(hostname, login_url, name, notes, http_proxy_port_number, ssh_server_port_number, ".
             " ssh_server_fingerprint, ssh_user_name, ssh_user_password) ".
             "VALUES ".
             "(:hostname, :login_url, :name, :notes, :http_proxy_port_number, :ssh_server_port_number, ".
             " :ssh_server_fingerprint, :ssh_user_name, :ssh_user_password)";
    db_query_execute($config, $query, convert_null_array(array(
            ":hostname" => $hostname,
            ":login_url" => $proxy_login_url,
            ":name" => $name,
            ":notes" => $notes,
            ":http_proxy_port_number" => $http_proxy_port_number,
            ":ssh_server_port_number" => $ssh_server_port_number,
            ":ssh_server_fingerprint" => $ssh_server_fingerprint,
            ":ssh_user_name" => $ssh_user_name,
            ":ssh_user_password" => $ssh_user_password)));

    $last = db_get_last_insert_id($config);
    break;
}

while ($_POST[id]=(int)$_POST[id])
{
    $hostname = trim($_POST['hostname']);
    if (!$hostname || !is_hostname($hostname))
    {
        $_GET[edit] = $_POST[id];
        $curs="frm.hostname";
        $processing_errors[] = ___("Wrong IP syntax");
        break;
    }
    
    // Trim leading and trailing whitespace and slashes
    $proxy_login_url = trim($_POST['login_url'], " \t\n\r\0\x0B/");

    // Validate without the leading and trailing slashes
    if(!is_login_url($proxy_login_url))
    {
        $_GET[edit] = $_POST[id];
        $curs="frm.login_url";
        $processing_errors[] = ___("Login URL contains illegal characters. Allowed characters are 'a-z', '0-9' and '/'");
        break;
    }

    // Make sure that login_url has a slash at the beginning and at the end.
    // This mitigates an issue with firefox where it caches redirects.
    // For example, if a proxy url is /001 (with no trailing slash), when logging
    // out, firefox will redirect to /001/, and a 404 will result.
    $proxy_login_url = "/" . $proxy_login_url . "/";

    $name = trim($_POST['name']);
    $notes = trim($_POST['notes']);
    $update_stats = isset($_POST['update_stats']);

    $http_proxy_port_number = trim($_POST['http_proxy_port_number']);
    $ssh_server_port_number = trim($_POST['ssh_server_port_number']);
    $ssh_server_fingerprint = trim($_POST['ssh_server_fingerprint']);
    $ssh_user_name = trim($_POST['ssh_user_name']);
    $ssh_user_password = trim($_POST['ssh_user_password']);

    // NOTE: Because we don't have transactions, there is a race condition between
    // the conflict check and the insert/update attempt. If a conflict is
    // introduced between the check and the insert/update, a DB error will occur.
    // This is unfortunate but acceptable (at this time).

    if (db_check_if_value_exists(
            $config,
            "proxy",
            "hostname",
            $hostname,
            "id != :id",
            array(":id" => $_POST['id'])))
    {
        $_GET[edit] = $_POST[id];
        $processing_errors[] = ___("Address already exists");
        $curs = "frm.hostname";
        break;
    }

    $query = "UPDATE proxy SET hostname = :hostname, login_url = :login_url, name = :name, notes = :notes, ".
             "http_proxy_port_number = :http_proxy_port_number, ssh_server_port_number = :ssh_server_port_number, ".
             "ssh_server_fingerprint = :ssh_server_fingerprint, ssh_user_name = :ssh_user_name, ".
             "ssh_user_password = :ssh_user_password WHERE id = :id";
    db_query_execute($config, $query, convert_null_array(array(
            ":hostname" => $hostname,
            ":login_url" => $proxy_login_url,
            ":name" => $name,
            ":notes" => $notes,
            ":http_proxy_port_number" => $http_proxy_port_number,
            ":ssh_server_port_number" => $ssh_server_port_number,
            ":ssh_server_fingerprint" => $ssh_server_fingerprint,
            ":ssh_user_name" => $ssh_user_name,
            ":ssh_user_password" => $ssh_user_password,
            ":id" => $_POST['id'])));

    // Proxy notes were added after stats had already been gathered, so we'll give
    // the user the option of copying the notes from the current edit to the stats
    // tables.
    if ($update_stats)
    {
        // stat_region
        $query = "UPDATE stat_region SET proxy_notes = :notes WHERE proxy = :proxy_id";
        db_query_execute($config, $query, convert_null_array(array(":notes" => $notes, ":proxy_id" => $_POST['id'])));

        // stat_site
        $query = "UPDATE stat_site SET proxy_notes = :notes WHERE proxy = :proxy_id";
        db_query_execute($config, $query, convert_null_array(array(":notes" => $notes, ":proxy_id" => $_POST['id'])));

        // stat_account_created
        $query = "UPDATE stat_account_created SET proxy_notes = :notes WHERE proxy = :proxy_id";
        db_query_execute($config, $query, convert_null_array(array(":notes" => $notes, ":proxy_id" => $_POST['id'])));
    }

    $last = $_POST[id];
    break;
}

include($_SERVER[DOCUMENT_ROOT]."/header.php");


?>
<script type="text/javascript" src="/js/xmlhttp.js"></script>
<script type="text/javascript">
function OnGenerateRandURL(form)
{
    xmlhttp.open("GET", "/getrand.php", true);
    xmlhttp.onreadystatechange=function() {
        if (xmlhttp.readyState==4) {
            form.login_url.value = '/' + xmlhttp.responseText;
        }
    }
    xmlhttp.send(null);
}
</script>

<form name="frm" method="post" action="<?=getenv("SCRIPT_NAME")?>">
<input name="csrf_token" value="<?=$record_user['csrf_token']?>" type="hidden">

<table cellpadding="2" cellspacing="0" border="0" class="brd">

<tr>
<th><?=___("Proxy Name")?></th>
<th><?=___("Hostname")?>/<?=___("Proxy IP")?></th>
<th><?=___("Proxy Login URL")?></th>
<th><?=___("Proxy Notes")?></th>
<th><?=___("Propagator Proxy Notes")?></th>

<!--<th><?=___("Last User Request")?></th>
<th><?=___("Avg. Daily Req.")?></th>-->
<th><?=___("http_proxy_port_number")?></th>
<th><?=___("ssh_server_port_number")?></th>
<th><?=___("ssh_server_fingerprint")?></th>
<th><?=___("ssh_user_name")?></th>
<th><?=___("ssh_user_password")?></th>
<th><a href="<?=getenv("SCRIPT_NAME")?>?add=1"><?=___("Add")?></a></th>
</tr>

<?
if ($_GET[add]) {
?>
<tr>
<td>
<input type="hidden" name="id" value="add">
<input type="text" name="name" maxlength="64" size="15" value="<?=escape_html($_POST['name'])?>">
</td>
<td><input type="text" name="hostname" maxlength="64" size="15" value="<?=escape_html($_POST['hostname'])?>"></td>
<td><input type="text" name="login_url" maxlength="64" size="32" value="<?=escape_html(($proxy_login_url ? $proxy_login_url : "/" . bin2hex(secure_rand())))?>">
<br>
<input type="button" onclick="OnGenerateRandURL(this.form);" value="<?=___("Generate random URL")?>">
</td>
<td><textarea name="notes" rows="10" cols="60" wrap="off" style="width:100%"><?=escape_html($_POST['notes'])?></textarea></td>
<!--<td></td>
<td></td>-->
<td></td>
<td><input type="text" name="http_proxy_port_number" maxlength="10" size="10" value="<?=escape_html($_POST['http_proxy_port_number'])?>"></td>
<td><input type="text" name="ssh_server_port_number" maxlength="10" size="10" value="<?=escape_html($_POST['ssh_server_port_number'])?>"></td>
<td><input type="text" name="ssh_server_fingerprint" maxlength="100" size="40" value="<?=escape_html($_POST['ssh_server_fingerprint'])?>"></td>
<td><input type="text" name="ssh_user_name" maxlength="100" size="15" value="<?=escape_html($_POST['ssh_user_name'])?>"></td>
<td><input type="text" name="ssh_user_password" maxlength="100" size="15" value="<?=escape_html($_POST['ssh_user_password'])?>"></td>
<td><input type="submit" value="<?=___("Add")?>"> &nbsp; <a href="<?=getenv("SCRIPT_NAME")?>"><?=___("Cancel")?></a></td>
</tr>

<?
}

$query = "SELECT proxy.*, ".proxy_label_sql("proxy")." AS label FROM proxy ORDER BY label";
$result = db_query_execute($config, $query, array());

while ($record = db_fetch_result($config, $result))
{
    // display stats
    //
    // - "average daily requests" is derived from stat_sites, which records
    //   requests per date/domain/user region/proxy.
    // - "most visited domain" is also from stat_sites
    // - "last user request" is derived from user last_activity.  this only
    //   picks up requests form users associated directly with a proxy, not
    //   with a group, so it's not completely accurate.  this may be replaced
    //   by a full "ping" background worker mechanism, or better real time
    //   stats recording (proxy.last_activity, for example)

    /*
    $average_daily_requests = '';
    $query1 = "SELECT AVG(daily_sum) AS average_daily_requests FROM ".
                "(SELECT SUM(cnt) AS daily_sum FROM stat_site ".
                   "WHERE proxy = :proxy ".
                   "GROUP BY date) AS daily_sums";
    $result1 = db_query_execute($config, $query1, convert_null_array(array(":proxy" => $record['id'])));

    $record1 = db_fetch_result($config, $result1);
    if ($record1) $average_daily_requests = (int)$record1['average_daily_requests'];
    */
    /*
    $most_visited_domain = '';
    $query1 = "SELECT domain, SUM(cnt) FROM stat_site ".
                "WHERE proxy = :proxy ".
                "GROUP BY domain ".
                "ORDER BY SUM(cnt) DESC ".
                "LIMIT 1";
    $result1 = db_query_execute($config, $query1, convert_null_array(array(":proxy" => $record['id'])));

    $record1 = db_fetch_result($config, $result1);
    if ($record1) $most_visited_domain = $record1['domain'];
    */
    /*
    $last_user_request = '';
    $query1 = "SELECT FROM_UNIXTIME(last_activity, '".___("%Y-%m-%d %H:%i:%S")."') AS last_user_request ".
                "FROM user ".
                "WHERE proxy = :proxy AND last_activity > 0 ".
                "ORDER BY last_activity DESC LIMIT 1";
    $result1 = db_query_execute($config, $query1, convert_null_array(array(":proxy" => $record['id'])));
    
    $record1 = db_fetch_result($config, $result1);
    if ($record1) $last_user_request = $record1['last_user_request'];
*/
    $_p=$_s="";

    if ($record[id]==$last) {
        $_p="{$_p}<b>";
        $_s="</b>{$_s}";
    }

    if ($record[id]==$record_user["current_proxy"]) {
        $_p="{$_p}<i>";
        $_s="</i>{$_s}";
    }

    echo "<tr>";

    if ($_GET[edit]!=$record[id]) {
        echo "<td>{$_p}".escape_html($record['name'])."{$_s}</td>\n";
        echo "<td>{$_p}".escape_html($record['hostname'])."{$_s}</td>\n";
        echo "<td>{$_p}".make_home_url($config, $record[id])."{$_s}</td>\n";

        if (strlen($record['notes']) == 0)
        {
            echo "<td>{$_p}".escape_html($record['notes'])."{$_s}</td>\n";
        }
        else
        {
            $rows = (int)substr_count($record['notes'], "\n");
            echo "<td>{$_p}<textarea rows=\"".$rows."\" cols=\"60\" wrap=\"off\" style=\"width:98%\" readonly>".escape_html($record['notes'])."</textarea></td>\n";
        }

        if (strlen($record['propagator_notes']) == 0)
        {
            echo "<td>{$_p}".escape_html($record['propagator_notes'])."{$_s}</td>\n";
        }
        else
        {
            $rows = (int)substr_count($record['propagator_notes'], "\n");
            echo "<td>{$_p}<textarea rows=\"".$rows."\" cols=\"60\" wrap=\"off\" style=\"width:98%\" readonly>".escape_html($record['propagator_notes'])."</textarea></td>\n";
        }
//        echo "<td>{$_p}{$last_user_request}{$_s}</td>\n";
//        echo "<td>{$_p}{$average_daily_requests}{$_s}</td>\n";
        echo "<td>{$_p}".escape_html($record['http_proxy_port_number'])."{$_s}</td>\n";
        echo "<td>{$_p}".escape_html($record['ssh_server_port_number'])."{$_s}</td>\n";
        echo "<td>{$_p}".escape_html($record['ssh_server_fingerprint'])."{$_s}</td>\n";
        echo "<td>{$_p}".escape_html($record['ssh_user_name'])."{$_s}</td>\n";
        echo "<td>{$_p}".escape_html($record['ssh_user_password'])."{$_s}</td>\n";
        echo "<td><a href=\"".getenv("SCRIPT_NAME")."?edit={$record[id]}\">{$_p}".___("Edit")."{$_s}</a> &nbsp;";
        echo "</td>\n";
    }
      else {
        echo "<td>";
        echo "<input type=\"hidden\" name=\"id\" value=\"{$record["id"]}\">";
        echo "<input type=\"text\" name=\"name\" maxlength=\"64\" size=\"15\" value=\"".escape_html($record['name'])."\">";
        echo "</td>\n";
        echo "<td>";
        echo "<input type=\"text\" name=\"hostname\" maxlength=\"64\" size=\"15\" value=\"".escape_html($record['hostname'])."\">";
        echo "</td>\n";
        echo "<td><input type=\"text\" name=\"login_url\" maxlength=\"32\" size=\"32\" value=\"". escape_html($proxy_login_url ? $proxy_login_url : $record['login_url'])."\">\n";
        echo "<br>\n";
        echo "<input type=\"button\" onclick=\"OnGenerateRandURL(this.form);\" value=\"" . ___("Generate random URL") ."\">\n";
        echo "</td>\n";
        echo "<td>";
        echo "<textarea name=\"notes\" rows=\"10\" cols=\"60\" wrap=\"off\" style=\"width:100%\">".escape_html($record['notes'])."</textarea>";
        echo "</td>\n";
        echo "<td>{$record['propagator_notes']}</td>\n";
//        echo "<td>{$last_user_request}</td>";
//        echo "<td>{$average_daily_requests}</td>";
        echo "<td>";
        echo "<input type=\"text\" name=\"http_proxy_port_number\" maxlength=\"10\" size=\"10\" value=\"".escape_html($record['http_proxy_port_number'])."\">";
        echo "</td>\n";
        echo "<td>";
        echo "<input type=\"text\" name=\"ssh_server_port_number\" maxlength=\"10\" size=\"10\" value=\"".escape_html($record['ssh_server_port_number'])."\">";
        echo "</td>\n";
        echo "<td>";
        echo "<input type=\"text\" name=\"ssh_server_fingerprint\" maxlength=\"100\" size=\"40\" value=\"".escape_html($record['ssh_server_fingerprint'])."\">";
        echo "</td>\n";
        echo "<td>";
        echo "<input type=\"text\" name=\"ssh_user_name\" maxlength=\"100\" size=\"15\" value=\"".escape_html($record['ssh_user_name'])."\">";
        echo "</td>\n";
        echo "<td>";
        echo "<input type=\"text\" name=\"ssh_user_password\" maxlength=\"100\" size=\"15\" value=\"".escape_html($record['ssh_user_password'])."\">";
        echo "</td>\n";
        echo "<td>";
        echo "<input type=\"submit\" value=\"".___("Update")."\"> &nbsp; <a href=\"".getenv("SCRIPT_NAME")."\">".___("Cancel")."</a>";
        echo "<br><br><input type='checkbox' name='update_stats' ".($_POST['update_stats'] ? 'checked=1' : '')." /><font size='small'>".___("Overwrite notes for existing stats")."</font>";
        echo "</td>\n";
    }

    echo "</tr>\n\n";
}


echo "</table>\n\n";


echo "</form>\n";


include($_SERVER[DOCUMENT_ROOT]."/footer.php");
?>
