<?php
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include_once($_SERVER[DOCUMENT_ROOT]."/includes/cr.php");
include_once($_SERVER[DOCUMENT_ROOT]."/includes/geoip_helpers.php");
include_once($_SERVER[DOCUMENT_ROOT]."/includes/url_extract_helpers.php");

// Do CSRF token check for GET in this case since it's an information leak when
// the user can be forced to browse (bluebar submit) to site attacker chooses.
// The CSRF token is included in the form rendered in bluebar.php.
$do_get_csrf = 1;
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");


if (!$record_user)
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
}

if (!($prefix = (string)$_SERVER["psiphon_html_prefix"])) {
    exit(0);
}

if (!strlen($url=trim($_GET["url"])))
    $url=trim($_GET["psiphon_url_display"]);

$url=str_replace("&amp;", "&", $url);

if ($url)
{
    if ( substr($url, 0, 7) != "http://" &&
         substr($url, 0, 8) != "https://" &&
         substr($url, 0, 6) != "ftp://" )
     {
         $url = "http://".$url;
     }
}

// get domain from $url
$domain=extract_domain($url);
if(strlen($domain))
{
    //update stats
    update_blue_bar_submit_stats($config, $domain, $record_user['last_reg'], $record_user['current_proxy'], $record_user['grp']);
}


$ret =$_SERVER["HTTPS"]?"https://":"http://";
$ret.=getenv("HTTP_HOST").substr(getenv("SCRIPT_NAME"), 0, strrpos(getenv("SCRIPT_NAME"), "/"));

header("HTTP/1.0 302 Found");
header("Location: {$ret}{$_SERVER["psiphon_html_prefix"]}/{$url}");

exit(0);
?>
