<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");

if (!user_has_permission($config, $record_user, "reports"))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
}

if (!$_GET["mf"]) {
    $_GET["mf"]=date("n"); $_GET["df"]=date("d"); $_GET["yf"]=date("Y");
    $_GET["mt"]=date("n"); $_GET["dt"]=date("d"); $_GET["yt"]=date("Y");
    $_GET["ord"]=0;
    $_GET["proxy"]=0;
    }
else {
    foreach (array("mf", "df", "yf", "mt", "dt", "yt", "rep", "ord", "proxy") as $var) {
        $_GET[$var]=(int)$_GET[$var];
        }
    // current report query
    $q="rep={$_GET["rep"]}&amp;".
    $q.="mf={$_GET["mf"]}&amp;df={$_GET["df"]}&amp;yf={$_GET["yf"]}&amp;";
    $q.="mt={$_GET["mt"]}&amp;dt={$_GET["dt"]}&amp;yt={$_GET["yt"]}&amp;";
    $q.="proxy={$_GET["proxy"]}";
    }

$title = ___("Reports");

$sql_params = array();

$from = mktime( 0, 0, 0,$_GET["mf"],$_GET["df"],$_GET["yf"]);
$to   = mktime(23,59,59,$_GET["mt"],$_GET["dt"],$_GET["yt"]);

// Don't use "date" in the param name, since there's a str_replace done on that string below.
$date_cond = "date > :dt_from AND date < :dt_to";
$sql_params[':dt_from'] = $from;
$sql_params[':dt_to'] = $to;

if ($_GET["proxy"])
{
    // Don't use "proxy" in the param name, since there's a str_replace done on that string below.
    $proxy_cond = "proxy = :proxy";
    $user_table_proxy_cond = "userproxy.proxyid = :proxy";
    $sql_params[':proxy'] = $_GET["proxy"];
}
else
{
    $proxy_cond = "1";
    $user_table_proxy_cond = "1";
}
$report_01_0=___("User");
$report_01_1=___("Date");
$report_01_2=___("Region");
$report_02_0=___("Date");
$report_02_1=___("Region");
$report_02_2=___("Count");
$report_03_0=___("Date");
$report_03_1=___("Domain");
$report_03_2=___("Count");
$report_04_0=___("Date");
$report_04_1=___("Domain");
$report_04_2=___("Region");
$report_04_3=___("Count");
$report_05_0=___("Date");
$report_05_1=___("Region");
$report_05_2=___("Count");
$report_06_0=___("Email");
$report_06_1=___("Created");
$report_06_2=___("Sent");
$report_06_3=___("Created by");
$reports = array(

// Handle group 4, Anonymous Users
// The default_sort_field is a 1-based index.
array(
    "report_title" => ___("Last logins"),
    "query" => "SELECT IF(grp = '".get_anonymous_user_class_id()."', '".get_user_class_name(get_anonymous_user_class_id())."', uname) AS report_01_0, IF(last, FROM_UNIXTIME(last, \"%Y-%m-%d %H:%i:%S\"), \"-\") as report_01_1 from user LEFT OUTER JOIN userproxy ON user.id = userproxy.userid where ".str_replace("date", "last", $date_cond)." and {$user_table_proxy_cond} GROUP BY uname",
    "default_sort_field" => "2",
    "total_field_count" => "2"),

array(
    "report_title" => ___("Region logins by day"),
    "query" => "SELECT FROM_UNIXTIME(date, '%Y-%m-%d') AS report_02_0, region AS report_02_1, SUM(cnt) AS report_02_2 FROM stat_region WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_02_0, region",
    "default_sort_field" => "1",
    "total_field_count" => "3"),

array(
    "report_title" => ___("Region logins by month"),
    "query" => "SELECT FROM_UNIXTIME(date, '%Y-%m') AS report_02_0, region AS report_02_1, SUM(cnt) AS report_02_2 FROM stat_region WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_02_0, region",
    "default_sort_field" => "1",
    "total_field_count" => "3"),

array(
    "report_title" => ___("Region logins by year"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y') AS report_02_0, region AS report_02_1, SUM(cnt) AS report_02_2 FROM stat_region WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_02_0, region",
    "default_sort_field" => "1",
    "total_field_count" => "3"),


array(
    "report_title" => ___("Sites by day"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y-%m-%d') AS report_03_0, domain AS report_03_1, SUM(cnt) AS report_03_2 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_03_0, domain",
    "default_sort_field" => "1",
    "total_field_count" => "3"),

array(
    "report_title" => ___("Sites by month"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y-%m') AS report_03_0, domain AS report_03_1, SUM(cnt) AS report_03_2 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_03_0, domain",
    "default_sort_field" => "1",
    "total_field_count" => "3"),

array(
    "report_title" => ___("Sites by year"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y') AS report_03_0, domain AS report_03_1, SUM(cnt) AS report_03_2 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_03_0, domain",
    "default_sort_field" => "1",
    "total_field_count" => "3"),


array(
    "report_title" => ___("Site, region by day"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y-%m-%d') AS report_04_0, domain AS report_04_1, region AS report_04_2, SUM(cnt) AS report_04_3 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_04_0, domain, region",
    "default_sort_field" => "1",
    "total_field_count" => "4"),

array(
    "report_title" => ___("Site, region by month"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y-%m') AS report_04_0, domain AS report_04_1, region AS report_04_2, SUM(cnt) AS report_04_3 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_04_0, domain, region",
    "default_sort_field" => "1",
    "total_field_count" => "4"),

array(
    "report_title" => ___("Site, region by year"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y') AS report_04_0, domain AS report_04_1, region AS report_04_2, SUM(cnt) AS report_04_3 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_04_0, domain, region",
    "default_sort_field" => "1",
    "total_field_count" => "4"),


array(
    "report_title" => ___("Requests by region per day"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y-%m-%d') AS report_05_0, region AS report_05_1, SUM(cnt) AS report_05_2 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_05_0, region",
    "default_sort_field" => "1",
    "total_field_count" => "3"),

array(
    "report_title" => ___("Requests by region per month"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y-%m') AS report_05_0, region AS report_05_1, SUM(cnt) AS report_05_2 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_05_0, region",
    "default_sort_field" => "1",
    "total_field_count" => "3"),

array(
    "report_title" => ___("Requests by region per year"), 
    "query" => "SELECT FROM_UNIXTIME(date, '%Y') AS report_05_0, region AS report_05_1, SUM(cnt) AS report_05_2 FROM stat_site WHERE {$date_cond} AND {$proxy_cond} GROUP BY report_05_0, region",
    "default_sort_field" => "1",
    "total_field_count" => "3"),

/*
 * Invitation reports  are left out for now as they display email addresses
 *
array(
    "report_title" => "report_06_q",
    "query" => "SELECT invitation.email AS report_06_0, FROM_UNIXTIME(date, '%Y-%m-%d %T') AS report_06_1 FROM invitation WHERE user = :user AND {$date_cond} AND status < 0 AND {$proxy_cond}", 
    "default_sort_field" => "1", 
    "total_field_count" => "2"),
$sql_params[':user'] = $record_user["id"];

array(
    "report_title" => "report_06_s", 
    "query" => "SELECT invitation.email AS report_06_0, FROM_UNIXTIME(status, '%Y-%m-%d %T') AS report_06_2 FROM invitation WHERE user = :user AND {$date_cond} AND status > 0 AND {$proxy_cond}", 
    "default_sort_field" => "1",
    "total_field_count" => "2"),
$sql_params[':user'] = $record_user["id"];

array(
    "report_title" => "report_06_qa",
    "query" => "SELECT invitation.invitation.email AS report_06_0, FROM_UNIXTIME(invitation.date, '%Y-%m-%d %T') AS report_06_1, user.uname AS report_06_3 FROM invitation, user WHERE ".str_replace("proxy", "invitation.proxy", $proxy_cond)." AND ".str_replace("date", "invitation.date", $date_cond)." AND invitation.status < 0 AND user.id = invitation.user", 
    "default_sort_field" => "1", 
    "total_field_count" => "3"),

array(
    "report_title" => "report_06_sa", 
    "query" => "SELECT invitation.email AS report_06_0, FROM_UNIXTIME(invitation.status, '%Y-%m-%d %T') AS report_06_2, user.uname AS report_06_3 FROM invitation, user WHERE ".str_replace("proxy", "invitation.proxy", $proxy_cond)." AND ".str_replace("date", "invitation.date", $date_cond)." AND invitation.status > 0 AND user.id = invitation.user", 
    "default_sort_field" => "1", 
    "total_field_count" => "3"),
*/
);

// Validate $_GET["rep"] and $_GET["ord"].
if ((isset($_GET["rep"]) && ($_GET["rep"] < 0 || $_GET["rep"] >= count($reports)))
    || (isset($_GET["ord"]) && (abs($_GET["ord"]) > $reports[$_GET["rep"]]['total_field_count'])))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
}

$record = false;

if (isset($_GET["rep"]))
{
    $title = ($reports[$_GET["rep"]]['report_title']);
    $query = $reports[$_GET["rep"]]['query'];

    if (!$_GET["ord"])
    {
        $_GET["ord"] = (int)$reports[$_GET["rep"]]['default_sort_field'];
    }

    // We CANNOT parameterize the ORDER BY clause.
    // From http://bugs.mysql.com/bug.php?id=31474
    // "Parameter markers can be used only where data values should appear, not for SQL keywords, identifiers, and so forth."
    // The best we can do is make sure the ordinal is really an int (and rely on the input validation above).
    $query .= " ORDER BY ".abs((int)$_GET["ord"]);

    if ($_GET["ord"]<0)
    {
        $query.=" DESC";
    }

    $result = db_query_execute($config, $query, convert_null_array($sql_params));

    // Get the first record, so we'll know if there are results or not.
    $record = db_fetch_result($config, $result);
}

// do not allow to download an empty file
if ($_GET["csv"] && !$record)
{
    $_GET["csv"] = 0;
}

if (!$_GET["csv"])
{
    include($_SERVER[DOCUMENT_ROOT]."/header.php");

    echo "<form method=\"get\" action=\"".getenv("SCRIPT_NAME")."\">\n";
    echo "<input name=\"csrf_token\" value=\"{$record_user['csrf_token']}\" type=\"hidden\">\n";

    echo "<b>\n<select name=\"rep\">\n";
    foreach ($reports as $var => $val)
    {
        echo "<option value=\"{$var}\"";
        if ($_GET["rep"]==$var) echo " selected";
        echo ">".($val['report_title'])."</option>\n";
    }
    echo "</select> \n\n";

    echo_proxy_combo($config, "proxy", $_GET["proxy"], 1, ___("Any proxy"));

    echo ___("From")."\n";
    echo "<select name=\"mf\">\n";
    for ($j=1; $j<=12; $j++) {
        echo "<option value=\"{$j}\"";
        if ($_GET["mf"]==$j) echo " selected";
        echo ">".strftime("%b",strtotime("{$j}/1/1970"))."</option>\n";
        }
    echo "</select> \n\n";

    echo "<select name=\"df\">\n";
    for ($j=1; $j<=31; $j++) {
        echo "<option value=\"{$j}\"";
        if ($_GET["df"]==$j) echo " selected";
        echo ">{$j}</option>\n";
        }
    echo "</select>, \n\n";

    echo "<select name=\"yf\">\n";
    for ($j=date("Y")-4; $j<=date("Y"); $j++) {
        echo "<option value=\"$j\"";
        if ($_GET["yf"]==$j) echo " selected";
        echo ">{$j}</option>\n";
        }
    echo "</select> \n\n";


    echo ___("To")."\n";
    echo "<select name=\"mt\">\n";
    for ($j=1; $j<=12; $j++) {
        echo "<option value=\"{$j}\"";
        if ($_GET["mt"]==$j) echo " selected";
        echo ">".strftime("%b",strtotime("{$j}/1/1970"))."</option>\n";
        }
    echo "</select> \n\n";

    echo "<select name=\"dt\">\n";
    for ($j=1; $j<=31; $j++) {
        echo "<option value=\"{$j}\"";
        if ($_GET["dt"]==$j) echo " selected";
        echo ">{$j}</option>\n";
        }
    echo "</select>, \n\n";

    echo "<select name=\"yt\">\n";
    for ($j=date("Y")-4; $j<=date("Y"); $j++) {
        echo "<option value=\"$j\"";
        if ($_GET["yt"]==$j) echo " selected";
        echo ">{$j}</option>\n";
        }
    echo "</select></b>\n\n";

    echo "<input type=\"submit\" value=\"".___("Display")."\">\n";
    echo "</form>\n\n";

    if ($record)
    {
        echo "<div id=\"result_count_div\" style=\"visibility:hidden; \"></div>\n";
        echo "&nbsp;&nbsp;&nbsp;<a href=\"".getenv("SCRIPT_NAME")."?y={$y}&amp;{$q}&amp;ord={$_GET["ord"]}&amp;csv=1\">".___("Download CSV")."</a>\n\n";
    }
    else
    {
        include($_SERVER[DOCUMENT_ROOT]."/footer.php");
        // footer.php calls exit, so we can assume below that there are results.
    }

    echo "<br>\n<br>\n\n";

    echo "<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\" class=\"brd\">\n";

    echo "<tr>\n";
}
else
{
    header("Content-Type: application/csv.ms-excel");
    header("Content-Disposition: attachment; filename=\"".str_replace(array(" ", ",", ";"), "_", $title).strftime("-%Y-%m-%d--", $from).strftime("%Y-%m-%d", $to).".csv\"");
}


$first = 1;

// header
$current_column = 0;
foreach ($record as $field => $val)
{
    $current_column++;

    if (!$_GET["csv"])
    {
        echo "<td align=\"center\"><a href=\"".getenv("SCRIPT_NAME")."?y={$y}&amp;{$q}&amp;ord=";
        if ($_GET["ord"] == $current_column)
            echo "-{$current_column}\"><b>".($$field)." /\\</b>";
        elseif ($_GET["ord" ]== -$current_column)
            echo  "{$current_column}\"><b>".($$field)." \\/</b>";
        else
            echo  "-{$current_column}\">".($$field);
        echo "</a></td>\n";
    }
    else
    {
        if ($current_column > 1) echo ",";
        echo "\"".str_replace("\"", "\"\"", ($$field))."\"";
    }
}

if (!$_GET["csv"])
{
    echo "</tr>\n\n";
}
else
{
    echo "\r\n";
}

$fc = count($record);
$row_count = 0;

do
{
    // Change the $record to have numeric indexes.
    $record = array_values($record);

    $row_count++;

    if (!$_GET["csv"])
    {
        echo "<tr>\n";
    }

    $first=1;

    for ($i=0; $i<$fc; $i++)
    {
        if (!$_GET["csv"])
        {
            echo "<td align=\"right\" nowrap>";
            if ($record[$i]!="")
                echo $record[$i];
            else
                echo "&nbsp;";
            echo "</td>\n";
        }
        else
        {
            if (!$first) echo ",";
            echo "\"".str_replace(array("\"", "\r", "\n"), array("\"\"", "\\r", "\\n"), $record[$i])."\"";
            $first=0;
        }
    }

    if (!$_GET["csv"])
    {
        echo "</tr>\n\n";
    }
    else
    {
        echo "\r\n";
    }
}
while ($record = db_fetch_result($config, $result));

if ($_GET["csv"])
{
    exit(0);
}

echo "</table>";

$result_count = "<br>".___("Rows:")."&nbsp; <b>".$row_count."</b>";
echo $result_count;
echo "<script type=\"text/javascript\">document.getElementById(\"result_count_div\").innerHTML=\"".$result_count."\";document.getElementById(\"result_count_div\").style.visibility=\"visible\";</script>\n";

include($_SERVER[DOCUMENT_ROOT]."/footer.php");
?>
