<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/text2line.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/head_w.php");

// Check user has permission to access this screen

if (!user_has_permission($config, $record_user, "send_ticket") &&
    !user_has_permission($config, $record_user, "manage_ticket"))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
    // 403.php exits
}

$title = ___("Create new ticket");
$curs="ticket.title";

if (user_has_permission($config, $record_user, "manage_ticket")) {
    $cond="";
    }
else {
    $cond="where user=\"{$record_user["id"]}\"";
    }

if (!$_GET["ret"]) {
    $_GET["ret"]="tickets.php";
    }

if ($_GET["url"]) {
    $_POST["title"]="Broken page";
    $_POST["body"] = $_GET["url"];
    }

while ($_POST["add"]) {

    $_POST["title"]=trim(text2line($_POST["title"]));
    $_POST["body"]=trim($_POST["body"]);

    if (!strlen($_POST["title"]) && !strlen($_POST["body"])) {
        break;
        }

    if (!strlen($ttitle=$_POST["title"])) {
        $ttitle=head_w(text2line($_POST["body"]), 40);
        }

    $head="-[ {$record_user["uname"]}, ".strftime("%F %I:%M %p", time())." ]-";
    for ($a=strlen($head); $a<87; $a++) $head.="-";
    $query =
        "INSERT INTO ticket ".
            "(user, last_user, last_date, title, body) VALUES ".
            "(:user, :last_user, UNIX_TIMESTAMP(), :title, :body)";

    db_query_execute(
        $config,
        $query,
        convert_null_array(array(
            ":user" => $record_user['id'],
            ":last_user" => $record_user['uname'],
            ":title" => $ttitle,
            ":body" => $head."\r\n\r\n".$_POST["body"])));

    $curs=$_POST["title"]=$_POST["body"]="";
    $processing_results[] = ___("Support ticket was created");
    break;
}

include($_SERVER[DOCUMENT_ROOT]."/header.php");

if (!$curs) {
    echo "{$title}<br><br>\n<a href=\"{$_GET["ret"]}\">".___("Continue")."</a><br>\n";
    include($_SERVER[DOCUMENT_ROOT]."/footer.php");
    }

?>
<form method="post" name="ticket" action="<?=getenv("SCRIPT_NAME")."?ret={$_GET["ret"]}"?>">
<input name="csrf_token" value="<?=$record_user['csrf_token']?>" type="hidden">

<input type="submit" value="<?=___("Submit")?>"> &nbsp;
<a href="<?=$_GET["ret"]?>"><?=___("Cancel")?></a>

<input type="hidden" name="add" value="1">

<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr>
<td align="right" width="1%" nowrap><?=___("Subject")?></td>
<td><input type="text" name="title" size="50" maxlength="80" value="<?=htmlentities($_POST["title"], ENT_QUOTES, charset())?>" style="width:100%"></td>
</tr>

<tr>
<td valign="top" align="right" width="1%" nowrap><?=___("Description")?></td>
<td><textarea name="body" rows="8" cols="43" style="width:100%">
<?=htmlentities($_POST["body"], ENT_QUOTES, charset())?></textarea></td>
</tr>

</table>

<input type="submit" value="<?=___("Submit")?>"> &nbsp;
<a href="<?=$_GET["ret"]?>"><?=___("Cancel")?></a>

</form>

<?
include($_SERVER[DOCUMENT_ROOT]."/footer.php");
?>
