<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/ft.php");

// Check user has permission to access this screen

if (!user_has_permission($config, $record_user, "send_ticket") &&
    !user_has_permission($config, $record_user, "manage_ticket"))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
    // 403.php exits
}

$cond_param_array = array();

if (user_has_permission($config, $record_user, "manage_ticket"))
{
    $cond = "";
}
else
{
    $cond = " AND user = :cond_user ";
    $cond_param_array[':cond_user'] = $record_user['id'];
}

$_GET["ofs"]=(int)$_GET["ofs"];
$_GET["id"]=(int)$_GET["id"];

$query = "SELECT * FROM ticket WHERE id = :id {$cond}";

$result = db_query_execute($config, $query, convert_null_array(array(":id" => $_GET['id']) + $cond_param_array));

if (!($record = escape_html(db_fetch_result($config, $result))))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/404.php");
}

db_free_result($result);

$updated = 0;

$title = ___("Ticket #")." {$record["id"]}: {$record["title"]}";

if (!$record["closed"])
{
    $curs="ticket.body";
}

while ($_POST["update"])
{
    if ($record["closed"])
    {
        $processing_results[] = ___("Ticket is closed");
        break;
    }

    $_POST["closed"]=(int)$_POST["closed"];

    if (!$_POST["closed"] && !strlen($_POST["body"]=trim($_POST["body"])))
    {
        break;
    }

    $body=$_POST["body"];

    if ($_POST["closed"])
    {
        $_GET["ofs"]=0;
        if (strlen($_POST["body"]))
        {
            $body.="\r\n\r\n".___("Ticket is closed");
        }
        else
        {
            $body.=___("Ticket is closed");
        }
    }

    $head="-[ {$record_user["uname"]}, ".strftime("%F %I:%M %p", time())." ]-";
    for ($a=strlen($head); $a<87; $a++) $head.="-";

    $query =
        "UPDATE ticket SET ".
            "last_user = :last_user, ".
            "last_date = UNIX_TIMESTAMP(), ".
            "closed = :closed, ".
            "body = concat(body, :new_body) ".
        "WHERE id = :id {$cond}";

    db_query_execute(
        $config,
        $query,
        convert_null_array(array(
            ":last_user" => $record_user['uname'],
            ":closed" => $_POST['closed'],
            ":new_body" => "\r\n\r\n{$head}\r\n\r\n{$body}",
            ":id" => $_GET[id])
            + $cond_param_array));

    $updated = 1;
    $processing_results[] = ___("Ticket was updated");
    break;
}

include($_SERVER[DOCUMENT_ROOT]."/header.php");

if ($updated)
{
    echo "{$title}<br><br>\n<a href=\"tickets.php?id={$_GET["id"]}\">".___("Continue")."</a><br>\n";
    include($_SERVER[DOCUMENT_ROOT]."/footer.php");
}

if (!$record["closed"])
{
?>
<form method="post" name="ticket" action="<?=getenv("SCRIPT_NAME")."?id={$_GET["id"]}&amp;ofs={$_GET["ofs"]}"?>">
<input name="csrf_token" value="<?=$record_user['csrf_token']?>" type="hidden">
<input type="hidden" name="update" value="1">

<?=ft($record["body"])?><br>
<br>

<?=___("Submit your comments")?>:<br>
<textarea name="body" rows="8" cols="43" tabindex="10" style="width:100%">
<?=htmlentities($_POST["body"], ENT_QUOTES, charset())?></textarea><br>
<label><input type="checkbox" name="closed" value="1" tabindex="30"> <?=___("close the ticket")?></label>
<br>
<br>
<input type="submit" value="<?=___("Submit")?>" tabindex="20"> &nbsp;
<a href="tickets.php?<?="ofs={$_GET["ofs"]}&amp;id={$_GET["id"]}"?>"><?=___("Cancel")?></a>
</form>
<?
    }
else {
    echo "<a href=\"tickets.php?y={$y}&amp;ofs={$_GET["ofs"]}&amp;id={$_GET["id"]}\">".___("Cancel")."</a><br><br>\n";
    echo ft($record["body"])."<br><br>\n";
    echo "<a href=\"tickets.php?y={$y}&amp;ofs={$_GET["ofs"]}&amp;id={$_GET["id"]}\">".___("Cancel")."</a><br><br>\n";
    }
include($_SERVER[DOCUMENT_ROOT]."/footer.php");
?>
