<?
/*
    Psiphon Circumvention Platform
    Copyright (C) 2009 Psiphon Inc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include_once($_SERVER[DOCUMENT_ROOT]."/includes/common_includes.php");
include($_SERVER[DOCUMENT_ROOT]."/check_user.php");
include($_SERVER[DOCUMENT_ROOT]."/includes/lang_set.php");

// Check user has permission to access this screen

if (!user_has_permission($config, $record_user, "send_ticket") &&
    !user_has_permission($config, $record_user, "manage_ticket"))
{
    include($_SERVER[DOCUMENT_ROOT]."/http-errors/403.php");
    // 403.php exits
}

$title = ___("Support tickets");

$cond_param_array = array();
if (user_has_permission($config, $record_user, "manage_ticket"))
{
    $cond = "";
}
else
{
    $cond = " WHERE user = :cond_user_id ";
    $cond_param_array[':cond_user_id'] = $record_user['id'];
}

// pager ///////////////////////////////////////////////////////////////////////
$query = "SELECT COUNT(*) AS cnt FROM ticket {$cond}";

$result = db_query_execute($config, $query, convert_null_array(array() + $cond_param_array));

$record = db_fetch_result($config, $result);
$count = $record["cnt"];
db_free_result($result);

$per_page = $config['tickets_ppage'];
if (($_GET["ofs"]=(int)$_GET["ofs"])<0) $_GET["ofs"]=0;
$last_page=floor(abs($count-0.1)/$per_page);
if ($_GET["ofs"]>$last_page) include($_SERVER[DOCUMENT_ROOT]."/http-errors/404.php");
$pn="<br>\n";
for ($page=0; $page<=$last_page; $page++)
{
    if ($page!=$_GET["ofs"])
    {
       $pn.="<a href=\"".getenv("SCRIPT_NAME")."?ofs={$page}\">".($page+1)."</a> &nbsp;\n";
   }
    else
    {
       $pn.="[ <b>".($page+1)."</b> ] &nbsp;\n";
   }
}

$limit_offset = abs((int)($_GET[ofs] * $per_page));
$limit_count = abs((int)$per_page);

// end of pager ////////////////////////////////////////////////////////////////

$query = "SELECT * FROM ticket {$cond} ORDER BY closed, id DESC LIMIT {$limit_offset}, {$limit_count}";

$result = db_query_execute($config, $query, convert_null_array(array() + $cond_param_array));

include($_SERVER[DOCUMENT_ROOT]."/header.php");
?>

<table cellpadding="3" cellspacing="0" border="0" class="brd">
    <tr>
        <th><?=___("Ticket #")?></th>
        <th><?=___("Subject")?></th>
        <th><?=___("Updated by")?></th>
        <th><?=___("Status")?></th>
        <td><a href="ticket-add.php"><b><?=___("Create new ticket")?></b></a></td>
    </tr>

<?
while ($record = escape_html(db_fetch_result($config, $result)))
{
    $_p=$_s="";
    if ($_GET["id"]==$record["id"])
    {
        $_p="<b>";
        $_s="</b>";
    }

    echo "<tr>\n";

    echo "<td>{$_p}{$record["id"]}{$_s}</td>\n";
    echo "<td>{$_p}{$record["title"]}{$_s}</td>\n";
    echo "<td>{$_p}{$record["last_user"]}, ".strftime("%F %I:%M %p", $record["last_date"])."{$_s}</td>\n";
    echo "<td>{$_p}";
    echo $record["closed"]?___("Closed"):"<b>".___("Open")."</b>";
    echo "{$_s}</td>\n";
    echo "<td>";
    echo "<a href=\"ticket-edit.php?id={$record["id"]}&amp;ofs={$_GET["ofs"]}\">{$_p}";
    echo $record["closed"]?___("View"):___("Update");
    echo "{$_s}</a></td>\n";
    echo "</tr>\n\n";
}

db_free_result($result);

echo "</table>";

if (strstr($pn, "href=")) echo "{$pn}\n";

include($_SERVER[DOCUMENT_ROOT]."/footer.php");
?>
