<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:atom="http://www.w3.org/2005/Atom"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:foo="http://purl.org/rss/1.0/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
    xmlns:admin="http://webns.net/mvcb/"
    xmlns:content="http://purl.org/rss/1.0/modules/content/"
    xmlns:wfw="http://wellformedweb.org/CommentAPI/"
    version="1.0">
    <xsl:output method="html"/>
    <xsl:template match="/">
      <html xmlns="http://www.w3.org/1999/xhtml">
      <head>
      </head>
      <body>

    <xsl:choose>
        <xsl:when test="atom:feed">
            <xsl:text>ATOM 1.0</xsl:text>
            <xsl:element name="h1"><xsl:value-of select="atom:feed/atom:title"/></xsl:element>
            <xsl:element name="ul">

                <xsl:for-each select="atom:feed/atom:entry">
                    <xsl:element name="li">
                        <xsl:element name="h2"><xsl:element name="a">
                            <xsl:attribute name="href">
                                <xsl:value-of select="atom:link[@rel='alternate']/@href"/>
                            </xsl:attribute>
                            <xsl:value-of select="atom:title"/>
                        </xsl:element></xsl:element>
                        <xsl:if test="atom:published">
                            <xsl:element name="div">
                                <xsl:attribute name="class">published</xsl:attribute>
                                Published: <xsl:value-of select="atom:published"/>
                            </xsl:element>
                        </xsl:if>
<!--                        <xsl:if test="atom:updated">
                            <xsl:element name="div">
                                <xsl:attribute name="class">updated</xsl:attribute>
                                    Updated: <xsl:value-of select="atom:updated"/>
                            </xsl:element>
                        </xsl:if>
-->
                        <xsl:element name="div">
                            <xsl:attribute name="class">entrydesc</xsl:attribute>
                            <xsl:if test="atom:summary">
                                <xsl:value-of select="atom:summary" />
                            </xsl:if>

                        </xsl:element>
                        <xsl:element name="div">
                            <xsl:attribute name="class">entrycontent</xsl:attribute>
                            <xsl:if test="atom:content[@type='html']">
                                <xsl:value-of select="atom:content" disable-output-escaping="yes"/>
                            </xsl:if>
                            <xsl:if test="atom:content[@type='xhtml']">
                                <xsl:copy-of select="atom:content" />
                            </xsl:if>
                            <xsl:if test="atom:content[@type='text']">
                                <xsl:value-of select="atom:content" disable-output-escaping="no"/>
                            </xsl:if>
                        </xsl:element>
                    </xsl:element>
                </xsl:for-each>
            </xsl:element>
        </xsl:when>
        <xsl:when test="/rdf:RDF">
            <xsl:text>RSS 1.0</xsl:text>
            <xsl:apply-templates select="/rdf:RDF/foo:channel"/>
        </xsl:when>
        <xsl:when test="/rss/channel">
            <xsl:text>RSS</xsl:text>
            <xsl:apply-templates select="/rss/channel"/>
        </xsl:when>
        <xsl:otherwise>
            <xsl:text>Can't recognize feed type, sorry :(</xsl:text>
         </xsl:otherwise>
    </xsl:choose>
    </body>
    </html>
    </xsl:template>
    <xsl:template match="/rdf:RDF/foo:channel">
        <xsl:element name="h1">
                <xsl:value-of select="foo:title"/>
        </xsl:element>
        <xsl:element name="ul">
                <xsl:apply-templates select="/rdf:RDF/foo:item"/>
        </xsl:element>
    </xsl:template>
    <xsl:template match="/rdf:RDF/foo:item">
        <xsl:element name="li">
            <xsl:element name="h2"><xsl:element name="a">
                <xsl:attribute name="href">
                    <xsl:value-of select="foo:link"/>
                </xsl:attribute>
                <xsl:attribute name="title">
                    <xsl:value-of select="foo:description"/>
                </xsl:attribute>
                <xsl:value-of select="foo:title"/>
            </xsl:element></xsl:element>
            <xsl:if test="dc:date">
                <xsl:element name="div">
                    <xsl:attribute name="class">published</xsl:attribute>
                    Published: <xsl:value-of select="dc:date"/>
                </xsl:element>
            </xsl:if>
            <xsl:element name="div">
                <xsl:attribute name="class">entrydesc</xsl:attribute>
                <xsl:choose>
                    <xsl:when test="content:encoded">
                        <xsl:value-of select="content:encoded" disable-output-escaping="yes" />
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="foo:description" disable-output-escaping="no" />
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:element>
        </xsl:element>
    </xsl:template>
    <xsl:template match="/rss/channel">
        <xsl:element name="h1">
                <xsl:value-of select="title"/>
        </xsl:element>
        <xsl:element name="ul">
            <xsl:attribute name="class">syndication-list</xsl:attribute>
                <xsl:apply-templates select="item"/>
        </xsl:element>
    </xsl:template>
    <xsl:template match="/rss/channel/item">
        <xsl:element name="li">
            <xsl:attribute name="class">syndication-list-item</xsl:attribute>
            <xsl:element name="h2"><xsl:element name="a">
                <xsl:attribute name="href">
                    <xsl:value-of select="link" />
                </xsl:attribute>
                <xsl:attribute name="title">
                    <xsl:value-of select="description" disable-output-escaping="yes"/>
                </xsl:attribute>
                <xsl:value-of select="title" disable-output-escaping="yes"/>
            </xsl:element></xsl:element>
            <xsl:if test="pubDate">
                <xsl:element name="div">
                    <xsl:attribute name="class">published</xsl:attribute>
                    Published: <xsl:value-of select="pubDate"/>
                </xsl:element>
            </xsl:if>
            <xsl:element name="div">
                <xsl:attribute name="class">entrydesc</xsl:attribute>
                <xsl:choose>
                    <xsl:when test="content:encoded">
                        <xsl:value-of select="content:encoded" disable-output-escaping="yes" />
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="description" disable-output-escaping="yes" />
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:element>
        </xsl:element>
    </xsl:template>
</xsl:stylesheet>