<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:atom="http://www.w3.org/2005/Atom">
    <xsl:output method="html"/>
  <xsl:template match="/">
    <html xmlns="http://www.w3.org/1999/xhtml">
      <head>
       <!-- <meta http-equiv="content-type" content="text/html; charset=UTF-8"/>-->
        <title><xsl:value-of select="atom:feed/atom:title"/></title>
      </head>
      <body>
        <h1><xsl:value-of select="atom:feed/atom:title"/></h1>
        <ul>

          <xsl:for-each select="atom:feed/atom:entry">
            <li>
              <h2><xsl:element name="a">
                <xsl:attribute name="href">
                  <xsl:value-of select="atom:link[@rel='alternate']/@href"/>
                </xsl:attribute>
                <xsl:value-of select="atom:title"/>
              </xsl:element></h2>
              <xsl:if test="atom:published">
                <div class="published">
                  Published: <xsl:value-of select="atom:published"/>
                </div>
              </xsl:if>
              <div class="entrydesc">
                <xsl:if test="atom:summary">
                  <xsl:value-of select="atom:summary"/>
                </xsl:if>

              </div>
              <div class="entrydesc">
                <xsl:if test="atom:content">
                  <xsl:copy-of select="atom:content" disable-output-escaping="no"/>
                </xsl:if>

              </div>
            </li>
          </xsl:for-each>
        </ul>
      </body>
    </html>

  </xsl:template>
</xsl:stylesheet>